// CellsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "io.h"
#include "HtmlHelp.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "PreviewDlg.h"
#include "AuxClasses.h"
#include "CellsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CVobBlankerApp theApp;
extern CString FormatDuration(DWORD duration);
extern DWORD AddDuration(DWORD dwDuration1, DWORD dwDuration2);
extern void MyInfoBox(LPCTSTR text);
extern void MyErrorBox(LPCTSTR text);
extern int readbuffer(uchar* caracter, FILE *in);
extern bool IsNav(uchar* buffer);
extern bool IsVideo(uchar* buffer);
extern CString Size_MBytes(__int64 i64size);


/////////////////////////////////////////////////////////////////////////////
// CCellsDlg dialog


CCellsDlg::CCellsDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CCellsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCellsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CCellsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCellsDlg)
	DDX_Control(pDX, IDC_PROGRESS1, m_ProgCell);
	DDX_Control(pDX, IDC_LISTCELLS, m_CList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCellsDlg, CDialog)
	//{{AFX_MSG_MAP(CCellsDlg)
	ON_NOTIFY(NM_RCLICK, IDC_LISTCELLS, OnRclickList)
	ON_BN_CLICKED(IDC_BUTTONEXTRACT, OnButtonextract)
	ON_NOTIFY(NM_CLICK, IDC_LISTCELLS, OnClickList)
	ON_BN_CLICKED(IDC_BUTTONEXTRACTALL, OnButtonextractall)
	ON_BN_CLICKED(IDC_BUTTONEXTRACTALL2, OnButtonextractall2)
	ON_BN_CLICKED(IDC_BUTTONBLANK, OnButtonblank)
	ON_BN_CLICKED(IDC_BUTTONKEEP, OnButtonkeep)
	ON_BN_CLICKED(IDC_BUTTONSUBS, OnButtonsubs)
	ON_BN_CLICKED(IDC_BUTTONKEEPALL, OnButtonkeepall)
	ON_BN_CLICKED(IDC_BUTTONBLANKALL, OnButtonblankall)
	ON_BN_CLICKED(IDC_BUTTONPREVCELL, OnButtonprevcell)
	ON_NOTIFY(NM_DBLCLK, IDC_LISTCELLS, OnDblclkListcells)
	ON_BN_CLICKED(IDC_BUTTONSTILL, OnButtonstill)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_BUTTONSPLIT, OnButtonsplit)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDABORT, OnAbort)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID__CELLEXTRACT, On__extract)
	ON_COMMAND(ID__CELLEXTRACTALL, On__extractall)
	ON_COMMAND(ID__CELLEXTRACTALL2, On__extractall2)
	ON_COMMAND(ID__CELLKEEP, On__keep)
	ON_COMMAND(ID__CELLBLANK, On__blank)
	ON_COMMAND(ID__CELLSUBS, On__subs)
	ON_COMMAND(ID__CELLBLANKALL, On__blankall)
	ON_COMMAND(ID__CELLKEEPALL, On__keepall)
	ON_COMMAND(ID__CELLPREV, On__prev)
	ON_COMMAND(ID__CELLSTILL, On__still)
	ON_COMMAND(ID__CELLSPLIT, On__split)
	ON_COMMAND(ID__CELLSELECTALL, On__selectall)


END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCellsDlg message handlers
BOOL CCellsDlg::OnInitDialog()
{
	int i,j;
	int n;
	CString csAux,csAux2;
	int nCell,nCells,nButtons;
	int VobId, CellId;
	__int64 i64Size;
	DWORD dwDuration, dwTotalDuration;
	bool bReused;
	uchar CellCat0, mychar, mychar2;
	int nPrg,nChap;
	int iAction;


	CDialog::OnInitDialog();

	if (m_iDomain==MENUS)
		csAux.Format(_T("CELLS IN MENU: VTS=%02d PGC=%02d"), m_nVTS, m_nT+1);
	else 
		csAux.Format(_T("CELLS IN TITLE: VTS=%02d PGC=%02d"), m_nVTS, m_nT+1);
	SetWindowText(csAux);

	m_bIsExtracting=false;

	//CLISTCTRL HEADERS
	i=0;

	m_CList.SetExtendedStyle( LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES );

	m_CList.InsertColumn( i, "#");
	m_CList.SetColumnWidth( i, 35); 
	i++;

	m_CList.InsertColumn( i, "Prg");
	m_CList.SetColumnWidth( i, 35); 
	i++;

	if (m_iDomain==TITLES)
	{
		m_CList.InsertColumn( i, "Cha");
		m_CList.SetColumnWidth( i, 35); 
		i++;
	}
	m_CList.InsertColumn( i, "VID");
	m_CList.SetColumnWidth( i, 30); 
	i++;
	m_CList.InsertColumn( i, "CID");
	m_CList.SetColumnWidth( i, 30); 
	i++;
//	if (m_iDomain==MENUS)
//	{
		m_CList.InsertColumn( i, "Buttons");
		m_CList.SetColumnWidth( i, 30); 
		i++;
//	}
	m_CList.InsertColumn( i, "Size");
	m_CList.SetColumnWidth( i, 60); 
	i++;
	m_CList.InsertColumn( i, "Duration");
	m_CList.SetColumnWidth( i, 80); 
	i++;
	m_CList.InsertColumn( i, "Total Duration");
	m_CList.SetColumnWidth( i, 80); 
	i++;
	m_CList.InsertColumn( i, "Reused");
	m_CList.SetColumnWidth( i, 40); 
	i++;
	m_CList.InsertColumn( i, "ILV");
	m_CList.SetColumnWidth( i, 30); 
	i++;
	m_CList.InsertColumn( i, "Cat");
	m_CList.SetColumnWidth( i, 30); 
	i++;
	m_CList.InsertColumn( i, "Action");
	m_CList.SetColumnWidth( i, 60); 
	i++;
	m_CList.InsertColumn( i, "Replacing Cell");
	m_CList.SetColumnWidth( i, 145); 
	i++;

	if (m_iDomain==TITLES)
	{
		nCells=theApp.m_nCells[m_nVTS][m_nT];
		iAction=theApp.m_iAction[m_nVTS][m_nT];
	}
	else
	{
		nCells=theApp.m_nMCells[m_nVTS][m_nT];
		iAction=theApp.m_iMAction[m_nVTS][m_nT];
	}

	dwTotalDuration=0;

	mychar='K';
	switch (iAction)
	{
	case KEEP:
		mychar='K';
		break;
	case BLANK:
		mychar='B';
		break;
	case STILLA:
		if (m_iDomain==MENUS) mychar='S';
		break;
	case STILLNA:
		if (m_iDomain==MENUS) mychar='Z';
		break;
	default:
		mychar='K';
		break;
	}
	if (iAction!=CELLBASED)
	{
		for (nCell=0;nCell<nCells;nCell++)
		{
			if (theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell && iAction==BLANK))
				mychar2='K';
			else
				mychar2=mychar;

			if (m_iDomain==TITLES)
				theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,mychar2);
			else
				theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,mychar2);
		}
	}

	for (nCell=0;nCell<nCells;nCell++)
	{
		theApp.GetCellInfo(m_iDomain, m_nVTS,m_nT,nCell, &VobId, &CellId, &dwDuration, &i64Size, &bReused, &CellCat0, &nButtons);
		dwTotalDuration=AddDuration(dwTotalDuration, dwDuration);

		// Cell number
		csAux.Format(_T("%d"),nCell+1);
		m_CList.InsertItem(nCell, csAux);
		j=1;

		nPrg=theApp.GetProgram(m_iDomain,m_nVTS,m_nT,nCell);
		if (nPrg<=0)
			csAux="";
		else
			csAux.Format(_T("%d"),nPrg);
		m_CList.SetItemText(nCell,j, csAux);
		j++;

		if (m_iDomain==TITLES)
		{
			nChap=theApp.GetChapter(m_nVTS,m_nT,nCell);
			if (nChap<=0)
				csAux="";
			else
				csAux.Format(_T("%d"),nChap);
			m_CList.SetItemText(nCell,j, csAux);
			j++;
		}
		// VobID
		csAux.Format(_T("%d"),VobId);
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// CellID
		csAux.Format(_T("%d"),CellId);
		m_CList.SetItemText(nCell,j, csAux);
		j++;
/*		if (m_iDomain==MENUS)
		{
			csAux.Format(_T("%d"),nButtons);
			m_CList.SetItemText(nCell,j, csAux);
			j++;
		}
*/
		if (m_iDomain==MENUS || (theApp.m_bAlreadyScan[m_nVTS] && nButtons!=-1))
			csAux.Format(_T("%d"),nButtons);
		else
			csAux="?";

		m_CList.SetItemText(nCell,j, csAux);
		j++;
		
		// Size
		csAux=Size_MBytes(i64Size);
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// Duration
		csAux=FormatDuration(dwDuration);
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// TotalDuration
		csAux=FormatDuration(dwTotalDuration);
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// Reused
		if (bReused)
			csAux="Yes";
		else
			csAux="No";
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// ILV
		if (CellCat0 & 0x04)
			csAux="Yes";
		else
			csAux="No";
		m_CList.SetItemText(nCell,j, csAux);
		j++;
		// CellCat
		csAux.Format(_T("%02X"),CellCat0);
		m_CList.SetItemText(nCell,j, csAux);
		j++;

		// Action
		csAux2="";
		if (m_iDomain==TITLES)
			mychar=theApp.m_csCellBased[m_nVTS][m_nT][nCell];
		else
			mychar=theApp.m_csMCellBased[m_nVTS][m_nT][nCell];

		switch (mychar)
		{
		case 'K':
			csAux="Keep";
			break;
		case 'B':
			csAux="Blank";
			break;
		case 'C':
			csAux="Cut";
			break;
		case 'S':
			csAux="Still with audio";
			break;
		case 'Z':
			csAux="Still w/o audio";
			break;
		case 'P':
			csAux="Split";
			break;
		case 'R':
			csAux="Replace";
			for (n=0; n<theApp.m_ACell_replace.GetSize(); n++)
			{
				if (theApp.m_ACell_replace[n].nT==m_nT &&
					theApp.m_ACell_replace[n].nCell==nCell &&
					theApp.m_ACell_replace[n].nVTS==m_nVTS &&
					theApp.m_ACell_replace[n].iDomain==m_iDomain)
					csAux2=theApp.m_ACell_replace[n].csPath;
			}
			break;
		default:
			csAux="Unknown";
			break;
		}
		if (mychar=='Z' || mychar=='S' )
		{
			for (n=0; n<theApp.m_ACellStillinfo.GetSize(); n++)
			{
				if (theApp.m_ACellStillinfo[n].nT==m_nT &&
					theApp.m_ACellStillinfo[n].nCell==nCell &&
					theApp.m_ACellStillinfo[n].nVTS==m_nVTS &&
					theApp.m_ACellStillinfo[n].iDomain==m_iDomain)
					csAux2=theApp.m_ACellStillinfo[n].csFileStill;
			}
		}
		m_CList.SetItemText(nCell,j, csAux);
		m_indexAction=j;
		j++;
//Replacing or Still
		m_CList.SetItemText(nCell,j, csAux2);
		m_indexReplace=j;
		j++;

	}

	// TOOLTIPS
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);


	m_wndToolTip.AddTool(GetDlgItem(IDCANCEL), "Quit" );
	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Apply changes" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONEXTRACT),    "Extracts selected Cell" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONEXTRACTALL), "Extracts all Cells in only one file" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONEXTRACTALL2), "Extracts all Cells: One file per cell" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONKEEP), "Keeps the cell as it is" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONBLANKALL), "Marks all the cells for blanking. If there is a reused one, creates a blank cell with a new VID/CID" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONKEEPALL), "Keeps all cells as they are" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONBLANK), "Blanks the selected cell. If it is a reused one, creates a blank cell with a new VID/CID" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONSUBS),  "Replaces the selected cell. If it is a reused one, uses a new VID/CID" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONSTILL),  "Reduces the selected cell to a still I Frame with or without audio" );

	m_ProgCell.SetRange( 0, 100 );
	m_ProgCell.SetPos(0);

	CWnd *pWnd;
	pWnd = GetDlgItem(IDC_STATICINFO);
	pWnd->SetWindowText("");


	UpdateData(FALSE);

	GetInitialCoord();
	
	CheckEnableButtons();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCellsDlg::GetInitialCoord() 
{
	CWnd* pWnd;
	CRect myRect;
	int OFFX;
	int OFFY;

	GetClientRect(&m_RectApp);
	GetWindowRect(&myRect);
	OFFX=(myRect.Width()-m_RectApp.Width())/2;    // OFFX=Border
	OFFY=myRect.Height()-m_RectApp.Height()-OFFX; // OFFY=Top border+Caption+Menu. 

	pWnd=GetDlgItem(IDC_STATICINFO);
	pWnd->GetWindowRect(&m_RectINFO);
	m_RectINFO.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_PROGRESS1);
	pWnd->GetWindowRect(&m_RectPROG);
	m_RectPROG.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_LISTCELLS);
	pWnd->GetWindowRect(&m_RectLIST);
	m_RectLIST.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONSUBS);
	pWnd->GetWindowRect(&m_RectBSUBS);
	m_RectBSUBS.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONBLANK);
	pWnd->GetWindowRect(&m_RectBBLANK);
	m_RectBBLANK.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONBLANKALL);
	pWnd->GetWindowRect(&m_RectBBLANKALL);
	m_RectBBLANKALL.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONSTILL);
	pWnd->GetWindowRect(&m_RectBSTILL);
	m_RectBSTILL.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONSPLIT);
	pWnd->GetWindowRect(&m_RectBSPLIT);
	m_RectBSPLIT.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONKEEP);
	pWnd->GetWindowRect(&m_RectBKEEP);
	m_RectBKEEP.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONKEEPALL);
	pWnd->GetWindowRect(&m_RectBKEEPALL);
	m_RectBKEEPALL.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONEXTRACT);
	pWnd->GetWindowRect(&m_RectBEXTRACT);
	m_RectBEXTRACT.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONEXTRACTALL);
	pWnd->GetWindowRect(&m_RectBEXTRACTALL);
	m_RectBEXTRACTALL.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONEXTRACTALL2);
	pWnd->GetWindowRect(&m_RectBEXTRACTALL2);
	m_RectBEXTRACTALL2.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONPREVCELL);
	pWnd->GetWindowRect(&m_RectBPREVCELL);
	m_RectBPREVCELL.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDOK);
	pWnd->GetWindowRect(&m_RectBOK);
	m_RectBOK.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDCANCEL);
	pWnd->GetWindowRect(&m_RectBCANCEL);
	m_RectBCANCEL.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDABORT);
	pWnd->GetWindowRect(&m_RectBABORT);
	m_RectBABORT.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);
}

void CCellsDlg::ReSizeList(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=cx-m_RectApp.right;
		ancho+=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(cy-m_RectApp.bottom);
		alto+=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left,myRect.top,ancho,alto);
	}
}

void CCellsDlg::ReSizeButton(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left+cx-m_RectApp.right,myRect.top,ancho,alto);
	}
}

void CCellsDlg::ReSizeButtonBottom(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left+cx-m_RectApp.right,myRect.top+(cy-m_RectApp.bottom),ancho,alto);
	}
}

void CCellsDlg::ReSizeBottom(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left,myRect.top+(cy-m_RectApp.bottom),ancho,alto);
	}
}

void CCellsDlg::ReSizeProgress(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=cx-m_RectApp.right;
		ancho+=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left,myRect.top+(cy-m_RectApp.bottom),ancho,alto);
	}
}


void CCellsDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	// TODO: Add your message handler code here

	CRect myRect;


	if (nType==SIZE_RESTORED  )
	{
		if (cx < m_RectApp.right *6/10)
		{
			cx=m_RectApp.right*6/10-m_RectApp.left;
		}
		if (cy < m_RectApp.bottom)
		{
			cy=m_RectApp.bottom-m_RectApp.top;
		}

	}

	ReSizeList(IDC_LISTCELLS,m_RectLIST,cx,cy);

	ReSizeButton(IDC_BUTTONSUBS,m_RectBSUBS,cx,cy);
	ReSizeButton(IDC_BUTTONBLANK,m_RectBBLANK,cx,cy);
	ReSizeButton(IDC_BUTTONBLANKALL,m_RectBBLANKALL,cx,cy);
	ReSizeButton(IDC_BUTTONSTILL,m_RectBSTILL,cx,cy);
	ReSizeButton(IDC_BUTTONSPLIT,m_RectBSPLIT,cx,cy);
	ReSizeButton(IDC_BUTTONKEEP,m_RectBKEEP,cx,cy);
	ReSizeButton(IDC_BUTTONKEEPALL,m_RectBKEEPALL,cx,cy);
	ReSizeButton(IDC_BUTTONEXTRACT,m_RectBEXTRACT,cx,cy);
	ReSizeButton(IDC_BUTTONEXTRACTALL,m_RectBEXTRACTALL,cx,cy);
	ReSizeButton(IDC_BUTTONEXTRACTALL2,m_RectBEXTRACTALL2,cx,cy);
	ReSizeButton(IDC_BUTTONPREVCELL,m_RectBPREVCELL,cx,cy);

	ReSizeButtonBottom(IDOK,m_RectBOK,cx,cy);
	ReSizeButtonBottom(IDCANCEL,m_RectBCANCEL,cx,cy);
	ReSizeButtonBottom(IDABORT,m_RectBABORT,cx,cy);

	ReSizeProgress(IDC_PROGRESS1,m_RectPROG,cx,cy);
	ReSizeBottom  (IDC_STATICINFO,m_RectINFO,cx,cy);

	RedrawWindow(NULL,NULL,RDW_INVALIDATE);   
}




void CCellsDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CCellsDlg::OnOK() 
{
	// TODO: Add extra validation here

	CDialog::OnOK();

}

void CCellsDlg::OnRclickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
		// TODO: Add your control notification handler code here
	CPoint point;
	CMenu menu;

	GetCursorPos(&point);

    VERIFY(menu.LoadMenu(IDR_MENUCELLS));
    CMenu* pPopup = menu.GetSubMenu(0);
    ASSERT(pPopup != NULL);

	CheckEnableMenu(pPopup);
    pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x,point.y , this);

	*pResult = 0;
}

void CCellsDlg::On__extract() 
{
	// TODO: Add your control notification handler code here
	OnButtonextract();
}
void CCellsDlg::On__keep() 
{
	// TODO: Add your control notification handler code here
	OnButtonkeep();
}
void CCellsDlg::On__extractall() 
{
	// TODO: Add your control notification handler code here
	OnButtonextractall();
}
void CCellsDlg::On__extractall2() 
{
	// TODO: Add your control notification handler code here
	OnButtonextractall2();
}
void CCellsDlg::On__blank() 
{
	// TODO: Add your control notification handler code here
	OnButtonblank();
}
void CCellsDlg::On__subs() 
{
	// TODO: Add your control notification handler code here
	OnButtonsubs();
}
void CCellsDlg::On__prev() 
{
	// TODO: Add your control notification handler code here
	OnButtonprevcell();
}
void CCellsDlg::On__still() 
{
	// TODO: Add your control notification handler code here
	OnButtonstill();
}
void CCellsDlg::On__split() 
{
	// TODO: Add your control notification handler code here
	OnButtonsplit();
}
void CCellsDlg::On__keepall() 
{
	// TODO: Add your control notification handler code here
	OnButtonkeepall();
}
void CCellsDlg::On__blankall() 
{
	// TODO: Add your control notification handler code here
	OnButtonblankall();
}
void CCellsDlg::OnButtonextract() 
{
	// TODO: Add your control notification handler code here
//	int m_nT,m_nVTS;
// Extraction of all selected cells 
// One big file including all cells
	
	int nCell;
	POSITION posCell;
	CString csAux;
	CString csFiltro,csTitulo;
	CString csSavePath;
	CWnd* pWnd;
	int iRet;
	BOOL BSplit1GB;

	posCell=m_CList.GetFirstSelectedItemPosition();
	pWnd = GetDlgItem(IDC_STATICINFO);

	if (posCell == NULL ) return;
	
	csFiltro = "VOB files";
	csFiltro += " (*.VOB)|*.VOB||";
	csTitulo = "Select Output File *.VOB";
// OpenFile Dlg construction 
	CCustomFileDialog dlgAbrir(IDD_MYCFILEDIALOG,
		FALSE,"VOB","VTS_01_1.VOB",
		OFN_EXPLORER|OFN_HIDEREADONLY,
		(const char*)csFiltro);
	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;

	if (dlgAbrir.DoModal() == IDOK)
	{
		BSplit1GB=dlgAbrir.m_BCheck1;

		csSavePath = dlgAbrir.GetPathName(); 
		if( (_access( csSavePath , 0 )) != -1 )
		{
			iRet=AfxMessageBox ("The selected file already exists. Overwrite?", MB_YESNO|MB_ICONQUESTION );
			if (iRet!=IDYES) 
			{
				pWnd->SetWindowText("");
				CheckEnableButtons();	
				return;
			}
		}
		csAux=csSavePath.Right(4);
		csAux.MakeUpper();

		if (csAux != _T(".VOB") )
		{
			MessageBox( "File extension has to be  \".VOB\"", "Error",  MB_OK | MB_ICONSTOP );
			CheckEnableButtons();	
			return;
		}
		if (csSavePath[csSavePath.GetLength()-5]!= '1' && BSplit1GB)
		{
			MessageBox( "Filename has to be  \"*_1.VOB\" if you want to split the output", "Error",  MB_OK | MB_ICONSTOP );
			CheckEnableButtons();	
			return;
		}

		theApp.m_csFout=csSavePath;
		if ((theApp.m_Fout=fopen (csSavePath,"wb"))==NULL)
		{
			theApp.m_csFout="";
			MessageBox( "Error opening file", "Error",  MB_OK | MB_ICONSTOP );
			pWnd->SetWindowText("");
			return;
		}
	}
	else return;
	
	m_bIsExtracting=true;
	CheckEnableButtons();
	
	while (posCell && m_bIsExtracting )
	{
		nCell=m_CList.GetNextSelectedItem(posCell);	
		if (m_iDomain==TITLES)
			csAux.Format(_T("Extracting VTS=%d  PGC=%d  Cell=%d..."), m_nVTS, m_nT+1, nCell+1);
		else
			csAux.Format(_T("Extracting VTS=%d  LU=%d  PGC=%d  Cell=%d..."),
		          m_nVTS, m_nLU+1, m_nT-theApp.m_nIniPGCinLU[m_nVTS][m_nLU]+1, nCell+1);

		pWnd->SetWindowText(csAux);

		if (theApp.ExtractCell(BSplit1GB, m_iDomain,m_nVTS,m_nT, nCell, this ) <0)
			m_bIsExtracting=false;
	
	}
	if (theApp.m_Fout!=NULL) fclose (theApp.m_Fout);
	theApp.m_Fout=NULL;
	theApp.m_csFout="";

	if (m_bIsExtracting)
		pWnd->SetWindowText("Done");
	else
		pWnd->SetWindowText("Aborted");

	m_bIsExtracting=false;
	CheckEnableButtons();
	
}

void CCellsDlg::On__selectall() 
{
	// TODO: Add your control notification handler code here

	int nCell,nCells;

	nCells=m_CList.GetItemCount();	

	for (nCell=0;nCell<nCells;nCell++)
		m_CList.SetItemState(nCell,LVIS_SELECTED,LVIS_SELECTED);


}


void CCellsDlg::UpdateProgress(int nPerc)
{
	if (nPerc <0 ) nPerc=0;
	if (nPerc >100 ) nPerc=100;
	m_ProgCell.SetPos(nPerc);
//	m_csPcProgress.Format(_T("%d %%"),nPerc);

	UpdateData(FALSE);
}


void CCellsDlg::CheckEnableButtons()
{
	CWnd* pWnd;
	POSITION posCell;
	UINT nSelected;
	int iAction;
//	int nCell;

	UpdateData(TRUE);

	if (m_iDomain==TITLES)
		iAction=theApp.m_iAction[m_nVTS][m_nT];
	else
		iAction=theApp.m_iMAction[m_nVTS][m_nT];

	if (theApp.m_bInProcess==true || m_bIsExtracting)
	{
		pWnd = GetDlgItem(IDC_BUTTONPREVCELL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONEXTRACT);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONEXTRACTALL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONEXTRACTALL2);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONBLANK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEP);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONBLANKALL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEPALL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONSUBS);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONSTILL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONSPLIT);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDABORT);
		pWnd->EnableWindow(TRUE);

		return;
	}

	pWnd = GetDlgItem(IDOK);
	pWnd->EnableWindow(TRUE);
	pWnd = GetDlgItem(IDCANCEL);
	pWnd->EnableWindow(TRUE);
	pWnd = GetDlgItem(IDABORT);
	pWnd->EnableWindow(FALSE);

	pWnd = GetDlgItem(IDC_BUTTONEXTRACTALL);
	pWnd->EnableWindow(TRUE);
	pWnd = GetDlgItem(IDC_BUTTONEXTRACTALL2);
	pWnd->EnableWindow(TRUE);
	if (iAction==SKIP)
	{
		pWnd = GetDlgItem(IDC_BUTTONBLANKALL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEPALL);
		pWnd->EnableWindow(FALSE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_BUTTONBLANKALL);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_BUTTONKEEPALL);
		pWnd->EnableWindow(TRUE);
	}
	posCell=m_CList.GetFirstSelectedItemPosition();
	nSelected=m_CList.GetSelectedCount();

	if (posCell != NULL )
	{
		pWnd = GetDlgItem(IDC_BUTTONEXTRACT);
		pWnd->EnableWindow(TRUE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_BUTTONEXTRACT);
		pWnd->EnableWindow(FALSE);
	}

	if (posCell != NULL && nSelected==1)
	{
		pWnd = GetDlgItem(IDC_BUTTONPREVCELL);
		pWnd->EnableWindow(TRUE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_BUTTONPREVCELL);
		pWnd->EnableWindow(FALSE);
	}

	if (posCell != NULL && iAction!=SKIP)
	{//Enable
		pWnd = GetDlgItem(IDC_BUTTONBLANK);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_BUTTONKEEP);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_BUTTONSUBS);
		pWnd->EnableWindow(TRUE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_BUTTONBLANK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEP);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONSUBS);
		pWnd->EnableWindow(FALSE);
	}

//	if (posCell != NULL && m_iDomain==MENUS && iAction!=SKIP)
	if (posCell != NULL && iAction!=SKIP)
	{//Enable
		pWnd = GetDlgItem(IDC_BUTTONSTILL);
		pWnd->EnableWindow(TRUE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_BUTTONSTILL);
		pWnd->EnableWindow(FALSE);
	}
	if (m_iDomain==TITLES && posCell != NULL && iAction!=SKIP && nSelected==1 )
	{//Enable
		pWnd = GetDlgItem(IDC_BUTTONSPLIT);
		pWnd->EnableWindow(TRUE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_BUTTONSPLIT);
		pWnd->EnableWindow(FALSE);
	}
}

void CCellsDlg::CheckEnableMenu(CMenu* pPopup)
{
	POSITION posCell;
	int iAction, nSelected;

	UpdateData(TRUE);
	if (m_iDomain==TITLES)
		iAction=theApp.m_iAction[m_nVTS][m_nT];
	else
		iAction=theApp.m_iMAction[m_nVTS][m_nT];
	if (theApp.m_bInProcess==true)
	{
		pPopup->EnableMenuItem(ID__CELLEXTRACT, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLEXTRACTALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLEXTRACTALL2, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLKEEP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLBLANK, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLSELECTALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLKEEPALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLBLANKALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLSUBS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLSTILL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		return;
	}

	pPopup->EnableMenuItem(ID__CELLSELECTALL, MF_BYCOMMAND | MF_ENABLED );	
	pPopup->EnableMenuItem(ID__CELLEXTRACTALL, MF_BYCOMMAND | MF_ENABLED );	
	pPopup->EnableMenuItem(ID__CELLEXTRACTALL2, MF_BYCOMMAND | MF_ENABLED );	
	if (iAction==SKIP)
	{
		pPopup->EnableMenuItem(ID__CELLKEEPALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLBLANKALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	}
	else
	{
		pPopup->EnableMenuItem(ID__CELLKEEPALL, MF_BYCOMMAND | MF_ENABLED );	
		pPopup->EnableMenuItem(ID__CELLBLANKALL, MF_BYCOMMAND | MF_ENABLED );	
	}

	posCell=m_CList.GetFirstSelectedItemPosition();
	nSelected=m_CList.GetSelectedCount();

	if (posCell != NULL && nSelected==1)
		pPopup->EnableMenuItem(ID__CELLEXTRACT, MF_BYCOMMAND | MF_ENABLED );	
	else
		pPopup->EnableMenuItem(ID__CELLEXTRACT, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );

	if (posCell != NULL && iAction!=SKIP)
	{
		pPopup->EnableMenuItem(ID__CELLKEEP, MF_BYCOMMAND | MF_ENABLED );	
		pPopup->EnableMenuItem(ID__CELLBLANK, MF_BYCOMMAND | MF_ENABLED );	
		pPopup->EnableMenuItem(ID__CELLSUBS, MF_BYCOMMAND | MF_ENABLED );	
	}
	else
	{
		pPopup->EnableMenuItem(ID__CELLKEEP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLBLANK, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__CELLSUBS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	}
	if (posCell != NULL && iAction!=SKIP)
		pPopup->EnableMenuItem(ID__CELLSTILL, MF_BYCOMMAND | MF_ENABLED );	
	else
		pPopup->EnableMenuItem(ID__CELLSTILL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );

	if (m_iDomain==TITLES && posCell != NULL && iAction!=SKIP && nSelected==1 )
		pPopup->EnableMenuItem(ID__CELLSPLIT, MF_BYCOMMAND | MF_ENABLED );	
	else
		pPopup->EnableMenuItem(ID__CELLSPLIT, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );

}

void CCellsDlg::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	CheckEnableButtons();
	*pResult = 0;
}

void CCellsDlg::DeleteReplaceCell(int nCell)
{
	int n;
	int VID,CID;

	if (m_iDomain==TITLES)
	{
		VID=theApp.CellVID(m_nVTS,m_nT,nCell);
		CID=theApp.CellCID(m_nVTS,m_nT,nCell);
	}
	else
	{
		VID=theApp.CellMVID(m_nVTS,m_nT,nCell);
		CID=theApp.CellMCID(m_nVTS,m_nT,nCell);
	}

	for(n=theApp.m_ACell_replace.GetSize()-1; n>=0;n--)
	{
		if (theApp.m_ACell_replace[n].nT== m_nT &&
			theApp.m_ACell_replace[n].nCell== nCell &&
			theApp.m_ACell_replace[n].nVTS==m_nVTS &&
			theApp.m_ACell_replace[n].iDomain==m_iDomain)
				theApp.m_ACell_replace.RemoveAt(n,1);
	}
}

void CCellsDlg::DeleteStillCell(int nCell)
{
	int n;
	int VID,CID;

	if (m_iDomain==TITLES)
	{
		VID=theApp.CellVID(m_nVTS,m_nT,nCell);
		CID=theApp.CellCID(m_nVTS,m_nT,nCell);
	}
	else
	{
		VID=theApp.CellMVID(m_nVTS,m_nT,nCell);
		CID=theApp.CellMCID(m_nVTS,m_nT,nCell);
	}

	for(n=theApp.m_ACellStillinfo.GetSize()-1; n>=0;n--)
	{
		if (theApp.m_ACellStillinfo[n].nT== m_nT &&
			theApp.m_ACellStillinfo[n].nCell== nCell &&
			theApp.m_ACellStillinfo[n].iDomain== m_iDomain &&
			theApp.m_ACellStillinfo[n].nVTS==m_nVTS)
				theApp.m_ACellStillinfo.RemoveAt(n,1);
	}
}

void CCellsDlg::DeleteSplitCell(int nCell)
{
	int n;
	int VID,CID;

	if (m_iDomain==TITLES)
	{
		VID=theApp.CellVID(m_nVTS,m_nT,nCell);
		CID=theApp.CellCID(m_nVTS,m_nT,nCell);
	}
	else
	{
		VID=theApp.CellMVID(m_nVTS,m_nT,nCell);
		CID=theApp.CellMCID(m_nVTS,m_nT,nCell);
	}

	for(n=theApp.m_ACellSplitinfo.GetSize()-1; n>=0;n--)
	{
		if (theApp.m_ACellSplitinfo[n].nT== m_nT &&
			theApp.m_ACellSplitinfo[n].nCell== nCell &&
			theApp.m_ACellSplitinfo[n].iDomain== m_iDomain &&
			theApp.m_ACellSplitinfo[n].nVTS==m_nVTS)
				theApp.m_ACellSplitinfo.RemoveAt(n,1);
	}
}

void CCellsDlg::DeleteCutCell(int nCell)
{
	int n;
	int VID,CID;

	if (m_iDomain==TITLES)
	{
		VID=theApp.CellVID(m_nVTS,m_nT,nCell);
		CID=theApp.CellCID(m_nVTS,m_nT,nCell);
	}
	else
	{
		VID=theApp.CellMVID(m_nVTS,m_nT,nCell);
		CID=theApp.CellMCID(m_nVTS,m_nT,nCell);
	}

	for(n=theApp.m_ACellCutinfo.GetSize()-1; n>=0;n--)
	{
		if (theApp.m_ACellCutinfo[n].nT== m_nT &&
			theApp.m_ACellCutinfo[n].nCell== nCell &&
			theApp.m_ACellCutinfo[n].iDomain== m_iDomain &&
			theApp.m_ACellCutinfo[n].nVTS==m_nVTS)
				theApp.m_ACellCutinfo.RemoveAt(n,1);
	}
}

void CCellsDlg::OnButtonextractall() 
{
	// TODO: Add your control notification handler code here
// Extraction of all cells in PGC
// Single files: Only one big file or split by 1GB

	int nCell,nCells;
	CString csAux;
	CString csFiltro,csTitulo;
	CString csSavePath;
	bool bReused;
	CWnd* pWnd;
	int iRet;
	BOOL BSplit1GB;

	pWnd = GetDlgItem(IDC_STATICINFO);
	
	csFiltro = "VOB files";
	csFiltro += " (*.VOB)|*.VOB||";
	csTitulo = "Select Output File *.VOB";
	// OpenFile Dlg construction 
	CCustomFileDialog dlgAbrir(IDD_MYCFILEDIALOG,
		FALSE,"VOB","VTS_01_1.VOB",
		OFN_EXPLORER|OFN_HIDEREADONLY,
		(const char*)csFiltro);
	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;

	if (dlgAbrir.DoModal() == IDOK)
	{
		BSplit1GB=dlgAbrir.m_BCheck1;

		csSavePath = dlgAbrir.GetPathName(); 
		if( (_access( csSavePath , 0 )) != -1 )
		{
			iRet=AfxMessageBox ("The selected file already exists. Overwrite?", MB_YESNO|MB_ICONQUESTION );
			if (iRet!=IDYES) 
			{
				CheckEnableButtons();	
				return;
			}
		}

		csAux=csSavePath.Right(4);
		csAux.MakeUpper();

		if (csAux != _T(".VOB") )
		{
			MessageBox( "File extension has to be  \".VOB\"", "Error",  MB_OK | MB_ICONSTOP );
			CheckEnableButtons();	
			return;
		}
		if (csSavePath[csSavePath.GetLength()-5]!= '1' && BSplit1GB)
		{
			MessageBox( "Filename has to be  \"*_1.VOB\" if you want to split the output", "Error",  MB_OK | MB_ICONSTOP );
			CheckEnableButtons();	
			return;
		}
		theApp.m_csFout=csSavePath;
		if ((theApp.m_Fout=fopen (csSavePath,"wb"))==NULL)
		{
			theApp.m_csFout="";
			MessageBox( "Error opening file", "Error",  MB_OK | MB_ICONSTOP );
			CheckEnableButtons();	
			return;
		}

		m_bIsExtracting=true;

		CheckEnableButtons();	
	
		if (m_iDomain==TITLES)
			nCells=theApp.m_nCells[m_nVTS][m_nT];
		else
			nCells=theApp.m_nMCells[m_nVTS][m_nT];

			
		for (nCell=0,bReused=false;nCell<nCells && bReused==false ;nCell++)
				bReused=theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell);

		iRet=IDNO;
		if (bReused)
			iRet=AfxMessageBox ("There are some reused cells.\nDo you want to include them in the extracted VOB?", MB_YESNO|MB_ICONQUESTION );
			
		for (nCell=0;nCell<nCells && m_bIsExtracting;nCell++)
		{
			bReused=theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell);
			if (iRet ==IDYES || bReused==false ) // Extract all cells
			{
				if (m_iDomain==TITLES)
					csAux.Format(_T("Extracting VTS=%d  PGC=%d  Cell=%d..."), m_nVTS, m_nT+1, nCell+1);
				else
					csAux.Format(_T("Extracting VTS=%d  LU=%d  PGC=%d  Cell=%d..."),
						m_nVTS, m_nLU+1, m_nT-theApp.m_nIniPGCinLU[m_nVTS][m_nLU]+1, nCell+1);
				pWnd->SetWindowText(csAux);
				if (theApp.ExtractCell(BSplit1GB, m_iDomain,m_nVTS,m_nT, nCell, this )<0)
					m_bIsExtracting=false;
				if (m_bIsExtracting)
					pWnd->SetWindowText("Done");
				else
					pWnd->SetWindowText("Aborted");
			}
		}
		if (theApp.m_Fout!=NULL) fclose (theApp.m_Fout);
		theApp.m_Fout=NULL;
		theApp.m_csFout="";
	}

	m_bIsExtracting=false;

	CheckEnableButtons();	
}


void CCellsDlg::OnButtonextractall2() 
{
	// TODO: Add your control notification handler code here
// Extraction of all cells in PGC
// Multiple files: One single file per cell

	int nCell,nCells;
	CString csAux;
	CString csFiltro,csTitulo;
	CString csSavePath;
	bool bReused;
	CWnd* pWnd;
	int iRet;
	int nIndex;

	pWnd = GetDlgItem(IDC_STATICINFO);
	
	csFiltro = "VOB files";
	csFiltro += " (*.VOB)|*.VOB||";
	csTitulo = "Select Output File *.VOB";
	// OpenFile Dlg construction 
	CFileDialogEx dlgAbrir(FALSE,"VOB","VTS_01_001.VOB",
		OFN_EXPLORER|OFN_HIDEREADONLY,
		(const char*)csFiltro);
	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;

	if (dlgAbrir.DoModal() == IDOK)
	{
		csSavePath = dlgAbrir.GetPathName(); 
		csAux=csSavePath.Right(7);
		csAux=csAux.Left(3);

		if ( (sscanf(csAux,"%d", &nIndex))!= 1) nIndex=1;

		csAux.Format(_T("%03d"),nIndex);
		csSavePath = csSavePath.Left(csSavePath.GetLength()-7) + csAux + ".VOB";

		if( (_access( csSavePath , 0 )) != -1 )
		{
			iRet=AfxMessageBox ("The selected file already exists. Overwrite?\n"+csSavePath, MB_YESNO|MB_ICONQUESTION );
			if (iRet!=IDYES) 
			{
				CheckEnableButtons();	
				return;
			}
		}

		m_bIsExtracting=true;

		CheckEnableButtons();	

		if (m_iDomain==TITLES)
			nCells=theApp.m_nCells[m_nVTS][m_nT];
		else
			nCells=theApp.m_nMCells[m_nVTS][m_nT];

			
		for (nCell=0,bReused=false;nCell<nCells && bReused==false ;nCell++)
				bReused=theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell);

		iRet=IDNO;
		if (bReused)
			iRet=AfxMessageBox ("There are some reused cells.\nDo you want to include them in the extracted VOB?", MB_YESNO|MB_ICONQUESTION );
			

		for (nCell=0;nCell<nCells && m_bIsExtracting;nCell++)
		{
			bReused=theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell);
			if (iRet ==IDYES || bReused==false ) // Extract all cells
			{
				csAux.Format(_T("%03d.VOB"),nCell+nIndex);
				csSavePath = csSavePath.Left(csSavePath.GetLength()-7)+csAux;
				if ((theApp.m_Fout=fopen (csSavePath,"wb"))==NULL)
				{
					MessageBox( "Error opening file. Aborting\n" + csSavePath, "Error",  MB_OK | MB_ICONSTOP );
					m_bIsExtracting=false;
					CheckEnableButtons();	
					return;
				}

				if (m_iDomain==TITLES)
					csAux.Format(_T("Extracting VTS=%d  PGC=%d  Cell=%d..."), m_nVTS, m_nT+1, nCell+1);
				else
					csAux.Format(_T("Extracting VTS=%d  LU=%d  PGC=%d  Cell=%d..."),
						m_nVTS, m_nLU+1, m_nT-theApp.m_nIniPGCinLU[m_nVTS][m_nLU]+1, nCell+1);
				pWnd->SetWindowText(csAux);
				if (theApp.ExtractCell(FALSE , m_iDomain,m_nVTS,m_nT, nCell, this )<0)
					m_bIsExtracting=false;
				if (m_bIsExtracting)
					pWnd->SetWindowText("Done");
				else
					pWnd->SetWindowText("Aborted");

				if (theApp.m_Fout!=NULL) fclose (theApp.m_Fout);
				theApp.m_Fout=NULL;
			}
		}
	}
	m_bIsExtracting=false;

	CheckEnableButtons();	
}

void CCellsDlg::OnButtonblank() 
{
	// TODO: Add your control notification handler code here
	int nCell;
	POSITION posCell;
//	CWnd* pWnd;
	CString csAux,csAux2;

	posCell=m_CList.GetFirstSelectedItemPosition();
//	pWnd = GetDlgItem(IDC_STATICINFO);

//	if (posCell != NULL )
	while (posCell)
	{	
		nCell=m_CList.GetNextSelectedItem(posCell);	
		csAux2="";
		if (m_iDomain==TITLES)
			theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'B');
		else
			theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'B');
		csAux="Blank";

		DeleteReplaceCell(nCell);
		DeleteStillCell(nCell);
		DeleteSplitCell(nCell);
		DeleteCutCell(nCell);

		if (theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell))
			MyInfoBox("You have selected a Cell already used in other/s PGC/s.\nA new VobId/CellId will be used in this cell, so this will be a completely new cell");

		m_CList.SetItemText(nCell,m_indexAction, csAux);
		m_CList.SetItemText(nCell,m_indexReplace, csAux2);
	}
}

void CCellsDlg::OnButtonkeep() 
{
	// TODO: Add your control notification handler code here
	int nCell;
	POSITION posCell;
//	CWnd* pWnd;
	CString csAux,csAux2;

	posCell=m_CList.GetFirstSelectedItemPosition();
//	pWnd = GetDlgItem(IDC_STATICINFO);

//	if (posCell != NULL )
	while (posCell)
	{	
		nCell=m_CList.GetNextSelectedItem(posCell);	
		csAux2="";
		if (m_iDomain==TITLES)
			theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'K');
		else
			theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'K');
		csAux="Keep";

		DeleteReplaceCell(nCell);
		DeleteStillCell(nCell);
		DeleteSplitCell(nCell);
		DeleteCutCell(nCell);


		m_CList.SetItemText(nCell,m_indexAction, csAux);
		m_CList.SetItemText(nCell,m_indexReplace, csAux2);
	}	
}

void CCellsDlg::OnButtonsubs() 
{
	// TODO: Add your control notification handler code here
	int nCell,n;
	POSITION posCell;
	CString csAux,csAux2,csPath;
	CString csFiltro,csTitulo;
	int VobId,CellId;
	CELL_REPLACE myCell_replace;
	FILE *in;
	uchar buffer[2048];
	bool bWarned;

	posCell=m_CList.GetFirstSelectedItemPosition();

	csAux="VTS_01_1.VOB";
	bWarned=false;

	while (posCell)
	{	
		nCell=m_CList.GetNextSelectedItem(posCell);	
		if (m_iDomain==TITLES)
		{
			VobId=theApp.CellVID(m_nVTS,m_nT,nCell);
			CellId=theApp.CellCID(m_nVTS,m_nT,nCell);
		}
	
		else
		{
			VobId=theApp.CellMVID(m_nVTS,m_nT,nCell);
			CellId=theApp.CellMCID(m_nVTS,m_nT,nCell);
		}
		csFiltro = "VOB files";
		csFiltro += " (*.VOB)|*.VOB||";
		csTitulo = "Select Replacing Cell File *.VOB";
	// OpenFile Dlg construction 
		CFileDialogEx dlgAbrir(TRUE,"VOB",csAux,
			OFN_EXPLORER|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,
			(const char*)csFiltro);
		dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;

// Check name: Must end in 1.VOB
		if (dlgAbrir.DoModal() == IDOK)
			csPath = dlgAbrir.GetPathName();
		else
		{
			csPath="";
			return;
		}
// Check name: Must end in .VOB
//		csPath.MakeUpper();
		csAux=csPath.Right(4);
		csAux.MakeUpper();

		if (csAux != ".VOB")
		{
			MyErrorBox("Please select a VOB: Filename must end in .VOB");
			return;
		}

/// Open file and check first pack
		in=fopen(csPath,"rb");
		if (in==NULL)
		{
			MyErrorBox("Unable to open selected file");
			return;
		}
		if (readbuffer(buffer,in) == 2048)
		{
			if (!IsNav(buffer))
			{
				MyErrorBox("Replacing Cell does not start with a Nav Pack");
				return;
			}
			while (readbuffer(buffer,in) == 2048 && !IsVideo(buffer));
			if (!IsVideo(buffer))
			{
				MyErrorBox("Unable to find a Video Pack in selected file");
				return;
			}
		}
		if (in !=NULL) fclose(in);

		DeleteReplaceCell(nCell);
		DeleteStillCell(nCell);
		DeleteSplitCell(nCell);
		DeleteCutCell(nCell);

		myCell_replace.nT=m_nT;
		myCell_replace.nCell=nCell;
		myCell_replace.iDomain=m_iDomain;
		myCell_replace.nVTS=m_nVTS;
		myCell_replace.csPath=csPath;
		theApp.m_ACell_replace.SetAtGrow(theApp.m_ACell_replace.GetSize(),myCell_replace);

		csAux2=csPath;
		if (m_iDomain==TITLES)
			theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'R');
		else
			theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'R');
		csAux="Replace";

		if (!bWarned && theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell))
		{
			MyInfoBox("You have selected a Cell already used in other/s PGC/s.\n\
A new VobId/CellId will be used in this cell,\n\
so this will be a completely new cell.\n\nThis warning won't be shown again");
			bWarned=true;
		}
		m_CList.SetItemText(nCell,m_indexAction, csAux);
		m_CList.SetItemText(nCell,m_indexReplace, csAux2);

// Next dialog default name
		csAux=csPath.Right(csPath.GetLength()-csPath.ReverseFind('\\')-1);
		n=csAux.GetLength();
		csAux2=csAux.Right(4);
		csAux2.MakeUpper();
		if (csAux2 == _T(".VOB") )
		{
			if ( csAux[n-6]=='_' && isdigit(csAux[n-5]))
			{
				 csAux2=csAux.Left(n-5);
				 n=csAux[n-5]-'0'+1;
				 csAux.Format("%s%d.VOB",csAux2,n);
			}
			else if ( csAux[n-8]=='_' && isdigit(csAux[n-5]) &&
				      isdigit(csAux[n-6]) && isdigit(csAux[n-7]) )
			{
				 csAux2=csAux.Left(n-7);
				 n=csAux[n-5]-'0'+10*(csAux[n-6]-'0')+10*(csAux[n-7]-'0')+1;
				 csAux.Format("%s%03d.VOB",csAux2,n);
			}
		}
	}	
}

void CCellsDlg::OnButtonkeepall() 
{
// TODO: Add your control notification handler code here
	int nCell,nCells;
	CString csAux,csAux2;

	if (m_iDomain==TITLES)
		nCells=theApp.m_nCells[m_nVTS][m_nT];
	else
		nCells=theApp.m_nMCells[m_nVTS][m_nT];

	for (nCell=0; nCell<nCells; nCell++)
	{	
		csAux2="";
		if (m_iDomain==TITLES)
			theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'K');
		else
			theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'K');
		csAux="Keep";

		DeleteReplaceCell(nCell);
		DeleteStillCell(nCell);
		DeleteSplitCell(nCell);
		DeleteCutCell(nCell);

		m_CList.SetItemText(nCell,m_indexAction, csAux);
		m_CList.SetItemText(nCell,m_indexReplace, csAux2);
	}		
}

void CCellsDlg::OnButtonblankall() 
{
// TODO: Add your control notification handler code here
	CString csAux,csAux2;
	bool bWarning;
	int nCells,nCell;

	if (m_iDomain==TITLES)
		nCells=theApp.m_nCells[m_nVTS][m_nT];
	else
		nCells=theApp.m_nMCells[m_nVTS][m_nT];

	for (nCell=0,bWarning=false; nCell<nCells; nCell++)
	{	
		csAux2="";
		if (m_iDomain==TITLES)
			theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'B');
		else
			theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'B');
		csAux="Blank";

		DeleteReplaceCell(nCell);
		DeleteStillCell(nCell);
		DeleteSplitCell(nCell);
		DeleteCutCell(nCell);

		if (theApp.IsReused(m_iDomain,m_nVTS,m_nT,nCell)) bWarning=true;

		m_CList.SetItemText(nCell,m_indexAction, csAux);
		m_CList.SetItemText(nCell,m_indexReplace, csAux2);
	}	

	if (bWarning)
		MyInfoBox("There is at least one Cell already used in other/s PGC/s.\nA new VobId/CellId will be used in these cells, so they will be completely new cells");

}

void CCellsDlg::OnButtonprevcell() 
{
	// TODO: Add your control notification handler code here
	int nCell;
	POSITION posCell;
	CPreviewDlg dlgPreview;
	char chAction;
	CString csAux, csAux2;


	posCell=m_CList.GetFirstSelectedItemPosition();

	if (posCell != NULL )
	{
		nCell=m_CList.GetNextSelectedItem(posCell);	
		if (m_iDomain==TITLES)
			chAction=theApp.m_csCellBased[m_nVTS][m_nT][nCell];
		else
			chAction=theApp.m_csMCellBased[m_nVTS][m_nT][nCell];
		dlgPreview.m_BEnableCut=FALSE;
		if (chAction=='K' || chAction=='C')
			dlgPreview.m_BEnableCut=TRUE;
		dlgPreview.m_nCell=nCell;
		dlgPreview.m_iModePrev=CELLPREV;
		dlgPreview.m_nT=m_nT;
		dlgPreview.m_nVTS=m_nVTS;
		dlgPreview.m_iDomain=m_iDomain;
		dlgPreview.m_bCheckAudio=TRUE;

		if (dlgPreview.DoModal()== IDOK)
		{
			if ((dlgPreview.iIniSector !=-1 || dlgPreview.iEndSector !=-1)) 
			{
				csAux2="";
				if (m_iDomain==TITLES)
					theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'C');
				else
					theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'C');
				csAux="Cut";
				
				DeleteReplaceCell(nCell);
				DeleteStillCell(nCell);
				DeleteSplitCell(nCell);
				
				m_CList.SetItemText(nCell,m_indexAction, csAux);
				m_CList.SetItemText(nCell,m_indexReplace, csAux2);
			}
			else if (dlgPreview.m_BEnableCut)
			{
				csAux2="";
				if (m_iDomain==TITLES)
					theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,'K');
				else
					theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,'K');
				csAux="Keep";
				
				DeleteReplaceCell(nCell);
				DeleteStillCell(nCell);
				DeleteSplitCell(nCell);
				DeleteCutCell(nCell);
				
				m_CList.SetItemText(nCell,m_indexAction, csAux);
				m_CList.SetItemText(nCell,m_indexReplace, csAux2);

			}
		}
	}

	UpdateData(FALSE);
}	

void CCellsDlg::OnButtonstill() 
{
	// TODO: Add your control notification handler code here
	int iRet,n;
	int nCell;
	int nSelected, VobId,CellId;
	POSITION posCell;
	CPreviewDlg dlgPreview;
	CELLSTILLINFO myCellStillinfo;
	uchar mychar;
	CString csAux,csPath;


	posCell=m_CList.GetFirstSelectedItemPosition();

	nSelected=m_CList.GetSelectedCount();

	if (posCell != NULL  && nSelected==1)
	{
		nCell=m_CList.GetNextSelectedItem(posCell);	
		if (m_iDomain==TITLES)
		{
			VobId=theApp.CellVID(m_nVTS,m_nT,nCell);
			CellId=theApp.CellCID(m_nVTS,m_nT,nCell);
		}
		else
		{
			VobId=theApp.CellMVID(m_nVTS,m_nT,nCell);
			CellId=theApp.CellMCID(m_nVTS,m_nT,nCell);
		}

	
		dlgPreview.m_BEnableCut=FALSE;
		dlgPreview.m_nCell=nCell;
		dlgPreview.m_iModePrev=MOTION2STILL;
		dlgPreview.m_nT=m_nT;
		dlgPreview.m_nVTS=m_nVTS;
		dlgPreview.m_iDomain=m_iDomain;
		dlgPreview.m_i64IFrame=-5;

		for(n=theApp.m_ACellStillinfo.GetSize()-1; n>=0;n--)
		{
			if (theApp.m_ACellStillinfo[n].nT== m_nT &&
				theApp.m_ACellStillinfo[n].nCell== nCell &&
				theApp.m_ACellStillinfo[n].iDomain== m_iDomain &&
				theApp.m_ACellStillinfo[n].nVTS==m_nVTS)
			{
				dlgPreview.m_i64IFrame=theApp.m_ACellStillinfo[n].i64IFrame;
				dlgPreview.m_csFileStill=theApp.m_ACellStillinfo[n].csFileStill;
			}
		}
		if (m_iDomain==TITLES)
			mychar=theApp.m_csCellBased[m_nVTS][m_nT][nCell];
		else
			mychar=theApp.m_csMCellBased[m_nVTS][m_nT][nCell];

		dlgPreview.m_bCheckAudio=FALSE;
		if (mychar=='S') dlgPreview.m_bCheckAudio=TRUE;
		if (mychar=='Z') dlgPreview.m_bCheckAudio=FALSE;

		if (m_iDomain==TITLES)
			dlgPreview.m_bCheckAudio=TRUE;
	
		iRet=dlgPreview.DoModal();	

		if (iRet==IDOK)
		{
			DeleteReplaceCell(nCell);
			DeleteStillCell(nCell);
			DeleteSplitCell(nCell);
			DeleteCutCell(nCell);

			myCellStillinfo.nT=m_nT;
			myCellStillinfo.nCell=nCell;
			myCellStillinfo.iDomain=m_iDomain;
			myCellStillinfo.nVTS=m_nVTS;
			myCellStillinfo.i64IFrame=dlgPreview.m_i64IFrame;
			myCellStillinfo.csFileStill=dlgPreview.m_csFileStill;
			csPath=dlgPreview.m_csFileStill;

			theApp.m_ACellStillinfo.SetAtGrow(theApp.m_ACellStillinfo.GetSize(),myCellStillinfo);
			if (dlgPreview.m_bCheckAudio ==TRUE ) { mychar='S'; csAux="Still with audio" ;}
			else { mychar='Z'; csAux="Still w/o audio" ;}
			if (m_iDomain==TITLES)
				theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,mychar);
			else
				theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,mychar);

			m_CList.SetItemText(nCell,m_indexAction, csAux);
			m_CList.SetItemText(nCell,m_indexReplace, csPath);
		}
	}

	if (posCell != NULL  && nSelected > 1)
	{
		iRet=IDYES;

		if (m_iDomain==MENUS)
			iRet=AfxMessageBox ("Selected cell/s will be converted to a still.\nDo you want to keep the audio?", MB_YESNO|MB_ICONQUESTION );
		
		if (iRet==IDYES ) { mychar='S'; csAux="Still with audio" ;}
		else { mychar='Z'; csAux="Still w/o audio" ;}

		while (posCell)
		{	
			nCell=m_CList.GetNextSelectedItem(posCell);	
			if (m_iDomain==TITLES)
				theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,mychar);
			else
				theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,mychar);

			DeleteReplaceCell(nCell);
			DeleteStillCell(nCell);
			DeleteSplitCell(nCell);
			DeleteCutCell(nCell);

			m_CList.SetItemText(nCell,m_indexAction, csAux);
			m_CList.SetItemText(nCell,m_indexReplace, "");
		}
	}
}

void CCellsDlg::OnButtonsplit() 
{
	// TODO: Add your control notification handler code here
	int iRet,n;
	int nCell;
	int nSelected, VobId,CellId;
	POSITION posCell;
	CPreviewDlg dlgPreview;
	CELLSPLITINFO myCellSplitinfo;
	uchar mychar;
	CString csAux,csPath;


	posCell=m_CList.GetFirstSelectedItemPosition();

	nSelected=m_CList.GetSelectedCount();

	if (posCell != NULL  && nSelected==1)
	{
		nCell=m_CList.GetNextSelectedItem(posCell);	
		if (m_iDomain==TITLES)
		{
			VobId=theApp.CellVID(m_nVTS,m_nT,nCell);
			CellId=theApp.CellCID(m_nVTS,m_nT,nCell);
		}
		else
		{
			VobId=theApp.CellMVID(m_nVTS,m_nT,nCell);
			CellId=theApp.CellMCID(m_nVTS,m_nT,nCell);
		}

	
		dlgPreview.m_BEnableCut=FALSE;
		dlgPreview.m_nCell=nCell;
		dlgPreview.m_iModePrev=CELLSPLIT;
		dlgPreview.m_nT=m_nT;
		dlgPreview.m_nVTS=m_nVTS;
		dlgPreview.m_iDomain=m_iDomain;
		dlgPreview.m_i64IFrame=0;
		dlgPreview.m_bCheckAudio=FALSE;


		for(n=theApp.m_ACellSplitinfo.GetSize()-1; n>=0;n--)
		{
			if (theApp.m_ACellSplitinfo[n].nT== m_nT &&
				theApp.m_ACellSplitinfo[n].nCell== nCell &&
				theApp.m_ACellSplitinfo[n].iDomain== m_iDomain &&
				theApp.m_ACellSplitinfo[n].nVTS==m_nVTS)
			{
				dlgPreview.m_i64IFrame=theApp.m_ACellSplitinfo[n].i64IFrame;
				dlgPreview.iIniIsClosed=theApp.m_ACellSplitinfo[n].iIniIsClosed;

				dlgPreview.m_bCheckProgram=FALSE;
				dlgPreview.m_bCheckChapter=FALSE;
				if (theApp.m_ACellSplitinfo[n].iSplitMode>0)
					dlgPreview.m_bCheckProgram=TRUE;
				if (theApp.m_ACellSplitinfo[n].iSplitMode==2)
					dlgPreview.m_bCheckChapter=TRUE;

				dlgPreview.m_csFileStill="";
			}
		}
//		if (m_iDomain==TITLES)
//			mychar=theApp.m_csCellBased[m_nVTS][m_nT][nCell];
//		else
//			mychar=theApp.m_csMCellBased[m_nVTS][m_nT][nCell];
		
		iRet=dlgPreview.DoModal();	

		if (iRet==IDOK)
		{
			DeleteReplaceCell(nCell);
			DeleteStillCell(nCell);
			DeleteSplitCell(nCell);
			DeleteCutCell(nCell);

			myCellSplitinfo.nT=m_nT;
			myCellSplitinfo.nCell=nCell;
			myCellSplitinfo.iDomain=m_iDomain;
			myCellSplitinfo.nVTS=m_nVTS;
			myCellSplitinfo.i64IFrame=dlgPreview.m_i64IFrame;
			myCellSplitinfo.iIniIsClosed=dlgPreview.iIniIsClosed;

			myCellSplitinfo.iSplitMode=0;
			if ( dlgPreview.m_bCheckProgram==TRUE)
				myCellSplitinfo.iSplitMode=1;
			if ( dlgPreview.m_bCheckChapter==TRUE)
				myCellSplitinfo.iSplitMode=2;

			theApp.m_ACellSplitinfo.SetAtGrow(theApp.m_ACellSplitinfo.GetSize(),myCellSplitinfo);
			mychar='P'; csAux="Split" ;
			if (m_iDomain==TITLES)
				theApp.m_csCellBased[m_nVTS][m_nT].SetAt(nCell,mychar);
			else
				theApp.m_csMCellBased[m_nVTS][m_nT].SetAt(nCell,mychar);

			m_CList.SetItemText(nCell,m_indexAction, csAux);
			m_CList.SetItemText(nCell,m_indexReplace, "");
		}
	}
}


void CCellsDlg::OnDblclkListcells(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here

	OnButtonprevcell();	

	*pResult = 0;
}


BOOL CCellsDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	
	HtmlHelp(NULL,theApp.m_csPath+"\\VobBlanker.chm::.\\htm\\Cells.htm", HH_DISPLAY_TOC, 0);
	return TRUE;
}


void CCellsDlg::OnAbort() 
{
	// TODO: Add your control notification handler code here
	theApp.m_bInProcess=m_bIsExtracting=false;
}
