// PathsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HtmlHelp.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "AuxClasses.h"
#include "PathsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CVobBlankerApp theApp;
extern CString SelectFolder (CString csTitulo, CString csStartFolder);

/////////////////////////////////////////////////////////////////////////////
// CPathsDlg dialog


CPathsDlg::CPathsDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CPathsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPathsDlg)
	m_csAuto = _T("");
	m_csInput = _T("");
	m_csMuxMan = _T("");
	m_csOutput = _T("");
	m_csWorking = _T("");
	//}}AFX_DATA_INIT
}


void CPathsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPathsDlg)
	DDX_Text(pDX, IDC_EDITAUTO, m_csAuto);
	DDX_Text(pDX, IDC_EDITINPUT, m_csInput);
	DDX_Text(pDX, IDC_EDITMUXMAN, m_csMuxMan);
	DDX_Text(pDX, IDC_EDITOUTPUT, m_csOutput);
	DDX_Text(pDX, IDC_EDITWORKING, m_csWorking);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPathsDlg, CDialog)
	//{{AFX_MSG_MAP(CPathsDlg)
	ON_BN_CLICKED(IDC_BUTTONAUTO, OnButtonauto)
	ON_BN_CLICKED(IDC_BUTTONINPUT, OnButtoninput)
	ON_BN_CLICKED(IDC_BUTTONMUXMAN, OnButtonmuxman)
	ON_BN_CLICKED(IDC_BUTTONOUTPUT, OnButtonoutput)
	ON_BN_CLICKED(IDC_BUTTONSAVE, OnButtonsave)
	ON_BN_CLICKED(IDC_BUTTONWORKING, OnButtonworking)
	ON_BN_CLICKED(IDC_BUTTONAUTOC, OnButtonautoc)
	ON_BN_CLICKED(IDC_BUTTONINPUTC, OnButtoninputc)
	ON_BN_CLICKED(IDC_BUTTONOUTPUTC, OnButtonoutputc)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPathsDlg message handlers

BOOL CPathsDlg::OnInitDialog()
{

	CDialog::OnInitDialog();

	m_csMuxMan = theApp.m_csMuxManPath;
	m_csWorking = theApp.m_csWorkingPath;
	m_csAuto = theApp.m_csAutoPath;
	m_csInput = theApp.m_csInputDefPath;
	m_csOutput = theApp.m_csOutputDefPath;


	UpdateData (FALSE);
	// TOOLTIPS
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONMUXMAN),  "Path to MuxMan.exe.\r\nUsed to encode BMPs in MPEG-2 stills" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_EDITMUXMAN),    "Path to MuxMan.exe.\r\nUsed to encode BMPs in MPEG-2 stills" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONWORKING), "Path to a working Folder to store temporary files.\r\nUsed when encoding BMPs" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_EDITWORKING),   "Path to a working Folder to store temporary files.\r\nUsed when encoding BMPs" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONOUTPUT),  "Path to default output folder.\r\nBrowsing will start from this point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_EDITOUTPUT),    "Path to default output folder.\r\nBrowsing will start from this point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONINPUT ),  "Path to default input folder.\r\nBrowsing will start from this point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_EDITINPUT ),    "Path to default input folder.\r\nBrowsing will start from this point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONAUTO  ),  "Path to auto save folder. Used to save log and project files automatically.\r\nIf empty, files won't be automatically saved" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_EDITAUTO  ),    "Path to auto save folder. Used to save log and project files automatically.\r\nIf empty, files won't be automatically saved" );


	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Apply, save paths in Registry and exit" );
	m_wndToolTip.AddTool(GetDlgItem(IDCANCEL), "Quit" );


	return TRUE;  // return TRUE  unless you set the focus to a control

}


void CPathsDlg::OnButtonmuxman() 
{
	// TODO: Add your control notification handler code here
	CString	csFiltro,csTitulo;
	CString csAux;

	// String del filtro de ficheros y del titulo
	UpdateData (TRUE);

	csFiltro = "MuxMan exe";
	csFiltro += " (MuxMan.exe)|MuxMan.exe||";
	csTitulo = "Select MuxMan executable";
	// OpenFile Dlg construction 
	CFileDialogEx dlgAbrir(TRUE,"exe","MuxMan.exe",
		OFN_EXPLORER|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,
		(const char*)csFiltro);
	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;

	if (dlgAbrir.DoModal() == IDOK)
	{
		m_csMuxMan = dlgAbrir.GetPathName(); 
		//TODO: Check name

		UpdateData (FALSE);
	}			
}


void CPathsDlg::OnButtonworking() 
{
	// TODO: Add your control notification handler code here

	CString	csPath;
	
	UpdateData (TRUE);

	if (m_csWorking.IsEmpty())
	{
		csPath=SelectFolder ("Select Working (temporal) Folder","C:\\");
	}
	else
		csPath=SelectFolder ("Select Working (temporal) Folder",m_csWorking);
	if (! csPath.IsEmpty())
	{
		m_csWorking= csPath;
//		m_csOutput.MakeUpper();
	}
	UpdateData (FALSE);
	
}

void CPathsDlg::OnOK() 
{
	// TODO: Add extra validation here

	theApp.m_csMuxManPath = m_csMuxMan;
	theApp.m_csWorkingPath= m_csWorking;
	theApp.m_csInputDefPath=m_csInput;
	theApp.m_csOutputDefPath=m_csOutput;
	theApp.m_csAutoPath=	m_csAuto;

	theApp.WriteProfileString("Paths",   "WorkingFolder" ,	m_csWorking);	
	theApp.WriteProfileString("Paths",   "MuxManPath" ,		m_csMuxMan);	
	theApp.WriteProfileString("Paths",   "OutputFolder" ,	m_csOutput);
	theApp.WriteProfileString("Paths",   "InputFolder" ,	m_csInput);
	theApp.WriteProfileString("Paths",   "AutoSaveFolder" ,	m_csAuto);

	CDialog::OnOK();
}

void CPathsDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CPathsDlg::OnButtonsave() 
{
	// TODO: Add your control notification handler code here
	// Not used, saved in OnOK
}


void CPathsDlg::OnButtonauto() 
{
	// TODO: Add your control notification handler code here
	CString	csPath;
	
	UpdateData (TRUE);

	if (m_csAuto.IsEmpty())
		csPath=SelectFolder ("Select Auto Save (project and log file) Folder","C:\\");
	else
		csPath=SelectFolder ("Select Auto Save (project and log file) Folder",m_csAuto);
	if (! csPath.IsEmpty())
		m_csAuto= csPath;
	UpdateData (FALSE);	
}

void CPathsDlg::OnButtoninput() 
{
	// TODO: Add your control notification handler code here
	CString	csPath;
	
	UpdateData (TRUE);

	if (m_csInput.IsEmpty())
		csPath=SelectFolder ("Select default input folder","C:");
	else
		csPath=SelectFolder ("Select default input folder",m_csInput);
	if (! csPath.IsEmpty())
		m_csInput= csPath;
	UpdateData (FALSE);		
}

void CPathsDlg::OnButtonoutput() 
{
	// TODO: Add your control notification handler code here
	CString	csPath;
	
	UpdateData (TRUE);

	if (m_csOutput.IsEmpty())
		csPath=SelectFolder ("Select default output folder","C:");
	else
		csPath=SelectFolder ("Select default output folder",m_csOutput);
	if (! csPath.IsEmpty())
		m_csOutput= csPath;

	UpdateData (FALSE);		
	
}


void CPathsDlg::OnButtonautoc() 
{
	// TODO: Add your control notification handler code here
	m_csAuto="";
	UpdateData(FALSE);	
}

void CPathsDlg::OnButtoninputc() 
{
	// TODO: Add your control notification handler code here
	m_csInput="";
	UpdateData(FALSE);
}

void CPathsDlg::OnButtonoutputc() 
{
	// TODO: Add your control notification handler code here
	m_csOutput="";
	UpdateData(FALSE);
}

BOOL CPathsDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	HtmlHelp(NULL,theApp.m_csPath+"\\VobBlanker.chm::.\\htm\\tools_dialog.htm", HH_DISPLAY_TOC, 0);
	
	return TRUE;
}
