// VideoAttrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HtmlHelp.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "VideoAttrDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CVobBlankerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CVideoAttrDlg dialog


CVideoAttrDlg::CVideoAttrDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CVideoAttrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVideoAttrDlg)
	m_chkaltb = FALSE;
	m_chkaps = FALSE;
	m_chkfield1 = FALSE;
	m_chkfield2 = FALSE;
	m_chkltb = FALSE;
	m_iRcamera = -1;
	m_iRdar = -1;
	m_iRmpeg = -1;
	m_iRNTSC = -1;
	m_iRres = -1;
	m_iRVBR = -1;
	//}}AFX_DATA_INIT
}


void CVideoAttrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVideoAttrDlg)
	DDX_Check(pDX, IDC_CHKALTB, m_chkaltb);
	DDX_Check(pDX, IDC_CHKAPS, m_chkaps);
	DDX_Check(pDX, IDC_CHKFIELD1, m_chkfield1);
	DDX_Check(pDX, IDC_CHKFIELD2, m_chkfield2);
	DDX_Check(pDX, IDC_CHKLTB, m_chkltb);
	DDX_Radio(pDX, IDC_RCAMERA, m_iRcamera);
	DDX_Radio(pDX, IDC_RDAR1, m_iRdar);
	DDX_Radio(pDX, IDC_RMPEG1, m_iRmpeg);
	DDX_Radio(pDX, IDC_RNTSC, m_iRNTSC);
	DDX_Radio(pDX, IDC_RRES720, m_iRres);
	DDX_Radio(pDX, IDC_RVBR, m_iRVBR);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVideoAttrDlg, CDialog)
	//{{AFX_MSG_MAP(CVideoAttrDlg)
	ON_BN_CLICKED(IDC_RNTSC, OnRntsc)
	ON_BN_CLICKED(IDC_RPAL, OnRpal)
	ON_BN_CLICKED(IDC_RMPEG1, OnRmpeg1)
	ON_BN_CLICKED(IDC_RMPEG2, OnRmpeg2)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//INITDIALOG
BOOL CVideoAttrDlg::OnInitDialog()
{
	m_iAttr=theApp.m_iVideoAttr[m_nVTS];

	m_iRNTSC=(m_iAttr & 0x1000) >> 12;
	m_iRmpeg=(m_iAttr & 0x4000) >> 14;
	m_iRdar =(m_iAttr & 0x0C00) >> 10;
	m_iRVBR =(m_iAttr & 0x0020) >> 5;
	m_iRres =(m_iAttr & 0x0018) >> 3;
	m_iRcamera	= m_iAttr & 0x0001;

	m_chkaltb	= !((m_iAttr & 0x0100) >> 8);
	m_chkaps	= !((m_iAttr & 0x0200) >> 9);
	m_chkltb	= (m_iAttr & 0x0004) >> 2;

	m_chkfield1 = (m_iAttr & 0x0080) >> 7;
	m_chkfield2 = (m_iAttr & 0x0040) >> 6;
	
	
	CheckStandard(FALSE);
	UpdateData(FALSE);

	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Modify VTS_XX_0.IFO and VIDEO_TS.IFO" );
	m_wndToolTip.AddTool(GetDlgItem(IDCANCEL), "Cancel" );


	return TRUE;  // return TRUE  unless you set the focus to a control
}

/////////////////////////////////////////////////////////////////////////////
// CVideoAttrDlg message handlers

void CVideoAttrDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CVideoAttrDlg::OnOK() 
{
	// TODO: Add extra validation here
	int ret;
	CString csAux;

	UpdateData(TRUE);

	m_iAttr=0;

	if ( m_iRNTSC) m_iAttr+= 0x1000;
	if ( m_iRmpeg) m_iAttr+= 0x4000;
	if ( m_iRVBR) m_iAttr+= 0x0020;
	if ( m_iRcamera) m_iAttr+= 0x0001;

	m_iAttr+= ((m_iRdar & 0x3 ) << 10 );
	m_iAttr+= ((m_iRres & 0x3 ) << 3 );

	if ( !m_chkaltb)	m_iAttr+= 0x0100;
	if ( !m_chkaps)		m_iAttr+= 0x0200;
	if ( m_chkltb)		m_iAttr+= 0x0004;
	if ( m_chkfield1)	m_iAttr+= 0x0080;
	if ( m_chkfield2)	m_iAttr+= 0x0040;


	if (m_iAttr != theApp.m_iVideoAttr[m_nVTS])
	{
		csAux="You are going to change VTS video attributes in destination IFOs.\n";
		csAux+="Changing AR or letterbox/PanScan flags can make subpictures don't work\n";
		csAux+="properly. Use pgcEdit to adjust the appropiate streams in each PGC.\n"; 
		csAux+="Do you really want to continue?";

		ret=AfxMessageBox (csAux,  MB_YESNO|MB_ICONQUESTION );

		if (ret==IDYES)
		{
			theApp.m_iVideoAttr[m_nVTS]=m_iAttr;
			theApp.m_iVideoAttrBK[m_nVTS]=m_iAttr;
			theApp.UpdateVideoAttr(m_nVTS);
		}
		else
			return;
	}

	CDialog::OnOK();
}

void CVideoAttrDlg::OnRntsc() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CheckStandard(FALSE);
	UpdateData(FALSE);

}

void CVideoAttrDlg::OnRpal() 
{
	// TODO: Add your control notification handler code here
	OnRntsc();	
}

void CVideoAttrDlg::CheckStandard(BOOL BForce) 
{
	CWnd *pWnd;

	if (m_iRNTSC == 0 )
	{
		pWnd = GetDlgItem(IDC_RRES720);
		pWnd->SetWindowText("720x480");
		pWnd = GetDlgItem(IDC_RRES704);
		pWnd->SetWindowText("704x480");
		pWnd = GetDlgItem(IDC_RRES352);
		pWnd->SetWindowText("352x480");
		pWnd = GetDlgItem(IDC_RRESVCD);
		pWnd->SetWindowText("352x240");

		pWnd = GetDlgItem(IDC_CHKFIELD1);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_CHKFIELD2);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_RFILM);
		pWnd->EnableWindow(FALSE);

	}
	else
	{
		pWnd = GetDlgItem(IDC_RRES720);
		pWnd->SetWindowText("720x576");
		pWnd = GetDlgItem(IDC_RRES704);
		pWnd->SetWindowText("704x576");
		pWnd = GetDlgItem(IDC_RRES352);
		pWnd->SetWindowText("352x576");
		pWnd = GetDlgItem(IDC_RRESVCD);
		pWnd->SetWindowText("352x288");

		pWnd = GetDlgItem(IDC_CHKFIELD1);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_CHKFIELD2);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_RFILM);
		pWnd->EnableWindow(TRUE);
	}
/*

 // MPEG-1 & MPEG-2 resolutions constraints
	if (m_iRmpeg == 0 )
	{
		pWnd = GetDlgItem(IDC_RRES720);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_RRES704);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_RRES352);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_RRESVCD);
		pWnd->EnableWindow(TRUE);
		if (BForce)		m_iRres = 3;
	}
	else
	{
		pWnd = GetDlgItem(IDC_RRES720);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_RRES704);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_RRES352);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_RRESVCD);
		pWnd->EnableWindow(FALSE);
		if (BForce && m_iRres == 3) m_iRres = 0;
	}
*/
}

void CVideoAttrDlg::OnRmpeg1() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CheckStandard(TRUE);
	UpdateData(FALSE);
	
}

void CVideoAttrDlg::OnRmpeg2() 
{
	// TODO: Add your control notification handler code here
OnRmpeg1() ;	
}

BOOL CVideoAttrDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	
	HtmlHelp(NULL,theApp.m_csPath+"\\VobBlanker.chm::.\\htm\\Video_Attributes.htm", HH_DISPLAY_TOC, 0);
	return TRUE;
}
