// VobBlanker.cpp : Defines the class behaviors for the application.
//
// Menus Processing Part


#include "stdafx.h"
#include "direct.h"
#include "sys/types.h"
#include "sys/stat.h"
#include "io.h"
#include "Winbase.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "VobBlankerDlg.h"
#include "LogDlg.h"
#include "InfoDlg.h"
#include "CellsDlg.h"
#include "Externs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


void CVobBlankerApp::ProcessMenu(int nVTS, CWnd* pDlg)
{
	int k;
	__int64 i64size, i64StillSector;
	CString csAuxIn,csAux;
	struct  _stati64 statbuf;
	int iVideoAttr;
	int nCells;
	bool bDeeply,bRef,bAlreadyKept;
	int nLastRefCell;
	int iCID,iVID,iVID_old;
	int nDeleted;
//	MENU_CELL_LIST myCell;

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Processing VOB (Menus)"));
	else
		csAux.Format(_T("VTS %02d: Processing VOB (Menus)"),nVTS);
	MyLog(csAux);

	m_Fin=m_Fout=NULL;
	i64size=0;

	m_ANavinfo.RemoveAll();
	for (k=0;k<8;k++)
		m_AAudioinfo[k].RemoveAll();
	for (k=0;k<32;k++)
		m_ASubsinfo[k].RemoveAll();

// Check if original menu exists
	if (nVTS!=0)
		csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
	else
		csAux.Format(_T("VIDEO_TS.VOB"));
	csAuxIn=m_csInputPath+'\\'+csAux;

	if (_stati64 ( csAuxIn, &statbuf)==0)
		i64size= statbuf.st_size;
	else
	{
		MyLog("          Menu does not exist, continuing");
//   Do not return. continue, may be the user has checked the 32k option
//		return;
	}
		
	iVideoAttr=m_iMVideoAttr[nVTS];

	FillSimpleVob(SimpleVob,iVideoAttr);

	if (((iVideoAttr & 0x1000)>>12) == PAL ) m_ticsperframe=3600;
	else m_ticsperframe=3003;

	m_ANavinfo.RemoveAll();

// Calculate Total number of packs.
	m_i64OutputLBA=0;
	m_i64TotalLBA=0;

	for (k=0; k<m_nMPGCs[nVTS];k++)
	{
		if (m_iMAction[nVTS][k]==KEEP )         m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==BLANK  )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==DELPBK )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==CELLBASED )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==ZERO    )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==REUSE   )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==STILLNA )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
		else if (m_iMAction[nVTS][k]==STILLA  )  m_i64TotalLBA+=(m_i64MPGCfsize[nVTS][k]/2048);
	}

	if( m_i64TotalLBA==0) m_i64TotalLBA=1;

	if (nVTS!=0)
		csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
	else
		csAux.Format(_T("VIDEO_TS.VOB"));

	m_csFout=m_csOutputPath+ '\\' +csAux;
	m_Fout=fopen(m_csFout,"wb");
// Reset temporary buffer counter
	m_nPackstobeWritten=0;

///////////////////////////////////////////////////////////////////////////
///             FIRST PHASE: LOOP INTO PGCS AND PREPARE CELLS  ////////////
///////////////////////////////////////////////////////////////////////////
	MyLog("--------------MENU VOB PREPARING PHASE-",GREEN15);

	nCells=m_MenuCells[nVTS].GetSize();

	for (k=0 ; k<nCells; k++)
	{
		m_MenuCells[nVTS][k].iMode=UNREF;
		m_MenuCells[nVTS][k].bFixPointers=false;
		m_MenuCells[nVTS][k].bToBeDeleted=false;
	}

	if (m_bCheckVobFill) FillMenuVobHoles(nVTS);

// Next seems not needed
//	FillMenuOutputVCIDs(nVTS);

	k=nCells;
	nCells=m_MenuCells[nVTS].GetSize();
	m_i64TotalLBA+=((nCells-k)*5);

	m_nVOBIDsInProcess = m_nMMaxVOBIDs[nVTS];

	for (k=0; k<m_nMPGCs[nVTS] && m_bInProcess==true;k++)
	{
		if (m_iMAction[nVTS][k]==KEEP )				MenuKeep(nVTS,k);
		else if (m_iMAction[nVTS][k]==BLANK )		MenuBlank(nVTS,k);
		else if (m_iMAction[nVTS][k]==DELPBK)		MenuDelpbk(nVTS,k);
		else if (m_iMAction[nVTS][k]==ZERO)			MenuZero(nVTS,k);
		else if (m_iMAction[nVTS][k]==REUSE)		MenuReuse(nVTS,k);
		else if (m_iMAction[nVTS][k]==CELLBASED)	MenuBasedCell(nVTS,k);
		else if (m_iMAction[nVTS][k]==STILLA)		MenuStill(nVTS,k,true);
		else if (m_iMAction[nVTS][k]==STILLNA)		MenuStill(nVTS,k,false);
	}	

///////////////////////////////////////////////////////////////////////////
/// Deletion of unreferenced cells in the middle of the VOB
	nCells=m_MenuCells[nVTS].GetSize();
	for (k=0 ; k<nCells; k++)
		m_MenuCells[nVTS][k].bToBeDeleted=false;

	nLastRefCell=0;
	for (k=0; k<nCells; k++)
		if (m_MenuCells[nVTS][k].iMode!=UNREF ) nLastRefCell=k;

	nDeleted=0;
	if (!m_bCheckVobMUnref)
	{
		for (k=(nLastRefCell-1); k>=0; k--)
		{
			if (m_MenuCells[nVTS][k].iMode==UNREF)
			{
				m_MenuCells[nVTS][k].bToBeDeleted=true;
				nDeleted++;
			}
		}
	}
	if (nDeleted)
	{
		m_i64TotalLBA-=(nDeleted*5);
		csAux.Format(_T("%d"),nDeleted);
		MyLog("     NOTE: Deleted " + csAux + " unreferenced cells (in the middle of the VOB)" ,CIAN15 );
		m_nNotes++;
	}

	if( m_i64TotalLBA<=0) m_i64TotalLBA=1;

///////////////////////////////////////////////////////////////////////////
/// Deletion of unreferenced cells at the last part of the VOB
	nCells=m_MenuCells[nVTS].GetSize();
	nDeleted=0;
	if (!m_bCheckVobLUnref)
	{
		for (k=(nCells-1), iVID_old=-1,bRef=bAlreadyKept=false; k>=0 ; k--)
		{
			if (m_MenuCells[nVTS][k].bToBeDeleted==false)
			{
				iVID=m_MenuCells[nVTS][k].VID;
				iCID=m_MenuCells[nVTS][k].CID;
				if (iVID != iVID_old) bRef=false;
				iVID_old=iVID;

				if (m_MenuCells[nVTS][k].iMode==UNREF && bRef==false && 
					(iCID != 1 || bAlreadyKept==false))
				{
					nDeleted++;
					m_MenuCells[nVTS][k].bToBeDeleted=true;
				}
				else bRef=bAlreadyKept=true;
			}
		}
	}
	if (nDeleted)
	{
		m_i64TotalLBA-=(nDeleted*5);
		csAux.Format(_T("%d"),nDeleted);
		MyLog("     NOTE: Deleted " + csAux + " unreferenced cells (the last ones of each VOBID)" ,CIAN15 );
		m_nNotes++;
	}

	if( m_i64TotalLBA<=0) m_i64TotalLBA=1;
	
///////////////////////////////////////////////////////////////////////////
////////// Do a deep scan if needed

	i64StillSector=(m_iIFrameMode+1)*(-1);
	for (k=0, bDeeply=false;k<nCells && bDeeply==false;k++)
	{
		if (i64StillSector ==-4  && 
		   (m_MenuCells[nVTS][k].iMode==STILLA || m_MenuCells[nVTS][k].iMode==STILLNA))
		bDeeply=true;
		if (m_MenuCells[nVTS][k].iMode==CELLBASED && 
			(m_MenuCells[nVTS][k].chMode=='Z' || m_MenuCells[nVTS][k].chMode=='S') )
		{
			if 	(m_MenuCells[nVTS][k].i64IFrame1==-4 || 
				 (m_MenuCells[nVTS][k].i64IFrame1==-5 && i64StillSector ==-4))
				bDeeply=true;
		}
	}

	if (bDeeply && m_bMaxIframeScan[nVTS]==false)
	{
		MyLog("     NOTE: Deeply scanning Menu Cells: Finding Largest IFrames" ,CIAN15 );
		m_nNotes++;
		GetMaxIFrameData(nVTS);
		m_bMaxIframeScan[nVTS]=true;
		MyLog("           Done."  );
	}

////////////////////////////////////////////
// Renumber VCIDs in final VOB. 
	FillMenuOutputVCIDs(nVTS);

///////////////////////////////////////////////////////////////////////////
///             SECOND PHASE: WRITE THE VOB ///////////////////////////////
///////////////////////////////////////////////////////////////////////////
	MyLog("--------------MENU VOB WRITING PHASE STARTED-",GREEN15);

	m_nVOBIDsInProcess = m_nMMaxVOBIDs[nVTS];

	m_bFixVobs=false;
	for (k=0;k<nCells && m_bInProcess==true;k++)
	{
		m_iFixDuration=0;
		if (m_MenuCells[nVTS][k].iMode==KEEP )			MenuCellKeep(nVTS,k,pDlg);
		else if (m_MenuCells[nVTS][k].iMode==BLANK )	MenuCellBlank(nVTS,k,pDlg);
//		else if (m_MenuCells[nVTS][k].iMode==DELPBK)	MenuCellDelpbk(nVTS,k,pDlg);
//		else if (m_MenuCells[nVTS][k].iMode==ZERO)		MenuCellZero(nVTS,k,pDlg);
//		else if (m_MenuCells[nVTS][k].iMode==REUSE)		MenuCellReuse(nVTS,k,pDlg);
		else if (m_MenuCells[nVTS][k].iMode==CELLBASED)	MenuCellBasedCell(nVTS,k,pDlg);
		else if (m_MenuCells[nVTS][k].iMode==STILLA)	MenuCellStill(nVTS, k,true, i64StillSector, pDlg);
		else if (m_MenuCells[nVTS][k].iMode==STILLNA)	MenuCellStill(nVTS, k,false, i64StillSector, pDlg);
		else if (m_MenuCells[nVTS][k].iMode==UNREF && 
				 m_MenuCells[nVTS][k].bToBeDeleted==false) MenuCellUnref(nVTS,k,pDlg);

		if (m_MenuCells[nVTS][k].bFixPointers ==true) m_bFixVobs=true;
	}

	if (m_BUseHDDBuffer != 0)
	{
		FlushMegaBuffer(m_MegaBuffer,m_nPackstobeWritten, m_Fout);
		m_nPackstobeWritten=0;
	}

	if (m_Fout!=NULL) fclose(m_Fout);
	if (m_Fin !=NULL) fclose(m_Fin);
	m_Fin=m_Fout=NULL;

	if ( m_bInProcess!=true ) return;

	i64size=0;
	if (_stati64 ( m_csFout, &statbuf)==0)
		i64size= statbuf.st_size;

	if (i64size==0 ) // && m_bCheck32kMenus==FALSE)
	{
		if (nVTS==0)
			csAux.Format(_T("VIDEO_TS: Menu final size= 0. Deleting menu."));
		else
			csAux.Format(_T("VTS %02d: Menu final size= 0. Deleting menu."),nVTS);
		MyLog(csAux);
		DeleteFile(m_csFout);
	}

	MyLog("--------------MENU VOB WRITING FINISHED-",GREEN15);

	FillMenuCellInfo(nVTS);

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Cell data array filled (Menus)"));
	else
		csAux.Format(_T("VTS %02d: Cell data array filled (Menus)"),nVTS);
	MyLog(csAux);

}

void CVobBlankerApp::FillMenuOutputVCIDs(int nVTS)
{
	int nC,nCells;
	int nV,nVIDs;
	int NCID,NVID;
	bool bVIDExists;

	nVIDs=GetMenuMaxVobId(nVTS);

	nCells=m_MenuCells[nVTS].GetSize();

///////////////////////////////////////////////////////////
// 1st: (Always needed) Fill the New VCID with the old ones.
	for (nC=0;nC<nCells;nC++)
	{
		m_MenuCells[nVTS][nC].NVID = m_MenuCells[nVTS][nC].VID;
		m_MenuCells[nVTS][nC].NCID = m_MenuCells[nVTS][nC].CID;
	}

//////////////////////////////////////////////////////////////////7
// 2nd: Renumber VCIDs with the lowest ones (if checked)
// Loop over all the VIDs. For each VID, loop over all the Cells
// For each Cell, change VID to the first unused and change CID with the first unused
	if (m_bCheckVobRenumber)
	{
		NVID=1;
		for (nV=1;nV<=nVIDs; nV++)
		{
			NCID=1;
			bVIDExists=false;
			for (nC=0;nC<nCells;nC++)
			{
				if (m_MenuCells[nVTS][nC].bToBeDeleted == false &&
					m_MenuCells[nVTS][nC].VID == nV)
				{
					bVIDExists=true;
					m_MenuCells[nVTS][nC].NVID = NVID ;
					m_MenuCells[nVTS][nC].NCID = NCID ;
					NCID++;
				}
			}
			if (bVIDExists) NVID++;
		}
	}
}


int CVobBlankerApp::FillMenuVobHoles(int nVTS)
{
// returns the number of cells inserted.
	int n,nCells,nInserted;
	int VID,CID;
	MENU_CELL_LIST myCell;
	int VidOld,CidOld;
	int i;


	nInserted=0;
	VidOld=0; CidOld=1;

	nCells=m_MenuCells[nVTS].GetSize();
	for (n=0;n<nCells;n++)
	{
		VID=m_MenuCells[nVTS][n].VID;
		CID=m_MenuCells[nVTS][n].CID;
		if (VID > (VidOld+1))
		{
			for (i=0; i<(VID-VidOld-1);i++)
			{
				myCell.VID=VidOld+1+i;
				myCell.CID=1;
				myCell.nButtons=0;
				myCell.iMode=UNREF;
				m_MenuCells[nVTS].InsertAt(n+i,myCell);
				nInserted++;
			}
		}
		else if (VID ==(VidOld+1))
		{
			if (CID!=1)
			{
				for (i=0; i<(CID-1);i++)
				{
					myCell.VID=VID;
					myCell.CID=i+1;
					myCell.nButtons=0;
					myCell.iMode=UNREF;
					m_MenuCells[nVTS].InsertAt(n+i,myCell);
					nInserted++;
				}
			}
		}
		else if (VID ==VidOld)
		{
			if (CID >(CidOld+1))
			{
				for (i=0; i<(CID-CidOld-1);i++)
				{
					myCell.VID=VID;
					myCell.CID=CidOld+i+1;
					myCell.nButtons=0;
					myCell.iMode=UNREF;
					m_MenuCells[nVTS].InsertAt(n+i,myCell);
					nInserted++;
				}
			}
		}
//		else ... VID/CID goes backwards.. Something was wrong, Unexpected..
		VidOld=VID;
		CidOld=CID;
	}
	return nInserted;
}

///////////////////////////////////////////////////////////////////////////
///             PGC Methods, called in First phase   //////////////////////
///////////////////////////////////////////////////////////////////////////

void CVobBlankerApp::MenuKeep(int nVTS,int nT)
{
	int nCell;
	CString csAux;
	int nLU,nPGC;
	int n;

	nLU=m_nLU_MPGC[nVTS][nT];
	nPGC=nT-m_nIniPGCinLU[nVTS][nLU];

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Keeping Menu LU %02d, PGC %02d"),nLU+1,nPGC+1);
	else
		csAux.Format(_T("VTS %02d: Keeping Menu LU %02d, PGC %02d"),nVTS,nLU+1,nPGC+1);
    MyLog(csAux);

//  Loop cell by cell 

	for (nCell=0; nCell<m_nMCells[nVTS][nT] ;nCell++)
	{
		n=MenuCellGetPos( nVTS, nT, nCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}
		if (m_MenuCells[nVTS][n].iMode==UNREF || m_MenuCells[nVTS][n].iMode==REUSE)
		{
			m_MenuCells[nVTS][n].iMode=KEEP;
			m_MenuCells[nVTS][n].bFixPointers=false;
		}
	}
}


void CVobBlankerApp::MenuBlank(int nVTS,int nT)
{
	CString csAux;
	int nLU,nPGC;
	int nCell;
	int n;


	nLU=m_nLU_MPGC[nVTS][nT];
	nPGC=nT-m_nIniPGCinLU[nVTS][nLU];

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Blanking Menu LU %02d, PGC %02d"),nLU+1,nPGC+1);
	else
		csAux.Format(_T("VTS %02d: Blanking Menu LU %02d, PGC %02d"),nVTS,nLU+1,nPGC+1);
    MyLog(csAux);

//  Loop cell by cell 

	for (nCell=0; nCell<m_nMCells[nVTS][nT] ;nCell++)
	{
		n=MenuCellGetPos( nVTS, nT, nCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}
		if (m_MenuCells[nVTS][n].iMode==UNREF || m_MenuCells[nVTS][n].iMode==REUSE)
		{
			m_MenuCells[nVTS][n].iMode=BLANK;
			m_MenuCells[nVTS][n].bFixPointers=false;
		}
	}

}

void CVobBlankerApp::MenuDelpbk(int nVTS,int nT)
{
	CString csAux;
	int nLU,nPGC;

	nLU=m_nLU_MPGC[nVTS][nT];
	nPGC=nT-m_nIniPGCinLU[nVTS][nLU];

	if(nVTS==0)
		csAux.Format(_T("VIDEO_TS: Deleting PBK Menu LU %02d, PGC %02d"),nLU+1,nPGC+1);
	else
		csAux.Format(_T("VTS %02d: Deleting PBK Menu LU %02d, PGC %02d"),nVTS,nLU+1,nPGC+1);
    MyLog(csAux);
/* To be done when processing output IFO, so input IFOs remain unchanged to allow re-run...
	m_nMCells[nVTS][nT]=0;
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+3]=0;
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+2]=0; // Programs

	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE6]=0; // offset to program map
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE6+1]=0; 
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE8]=0; // offset to playback
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE8+1]=0; 
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xEA]=0; // offset to position
	m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xEA+1]=0; 

	m_dwMDuration[nVTS][nT]=(m_dwMDuration[nVTS][nT] & 0x000000C0);
	Put4bytes((__int64) m_dwMDuration[nVTS][nT],&m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+4]);
*/
  }

void CVobBlankerApp::MenuZero(int nVTS,int nT)
{
	// Nothing to do.
}


void CVobBlankerApp::MenuReuse(int nVTS,int nT)
{
	CString csAux;
	int nLU,nPGC,nLUR;
	int nnT;
	int n,nCell;


	nLU=m_nLU_MPGC[nVTS][nT];
	nPGC=nT-m_nIniPGCinLU[nVTS][nLU];
	nLUR=m_iReuseLU[nVTS][nT];
	nnT=m_nIniPGCinLU[nVTS][nLUR]+nPGC;

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Menu LU %02d, PGC %02d, reusing from LU %02d"),nLU+1,nPGC+1,nLUR+1);
	else
		csAux.Format(_T("VTS %02d: Menu LU %02d, PGC %02d, reusing from LU %02d"),nVTS,nLU+1,nPGC+1,nLUR+1);
    MyLog(csAux);

//  Loop cell by cell 

	for (nCell=0; nCell<m_nMCells[nVTS][nnT] ;nCell++)
	{
		n=MenuCellGetPos( nVTS, nnT, nCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}
		if (m_MenuCells[nVTS][n].iMode==UNREF)
		{
//			m_MenuCells[nVTS][n].iMode=REUSE;
			m_MenuCells[nVTS][n].iMode=UNREF;
			m_MenuCells[nVTS][n].bFixPointers=false;
		}
	}
}

void CVobBlankerApp::MenuBasedCell(int nVTS,int nT)
{
	int n,nCell;
	CString csAux;
	bool bAlready;
	int CellId,VobId;
	int nLU,nPGC;
	MENU_CELL_LIST myCell;
	__int64 i64IFrame;
	int i;
	int indexReplace;
	__int64 i64IniSec, i64EndSec;
	int iIniSector,iEndSector,iIniIsClosed,iEndIsClosed, iAction;


	nLU=m_nLU_MPGC[nVTS][nT];
	nPGC=nT-m_nIniPGCinLU[nVTS][nLU];

	if(nVTS==0)
		csAux.Format(_T("VIDEO_TS: Cell Based Menu LU %02d, PGC %02d"),nLU+1,nPGC+1);
	else
		csAux.Format(_T("VTS %02d: Cell Based Menu LU %02d, PGC %02d"),nVTS,nLU+1,nPGC+1);
    MyLog(csAux);

//  Loop cell by cell 

	for (nCell=0; nCell<m_nMCells[nVTS][nT] ;nCell++)
	{
		n=MenuCellGetPos( nVTS, nT, nCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}
		if (m_MenuCells[nVTS][n].iMode==UNREF || m_MenuCells[nVTS][n].iMode==REUSE)
		{
			bAlready=false;
			m_MenuCells[nVTS][n].iMode=CELLBASED;
		}
		else bAlready=true;

		VobId=m_MenuCells[nVTS][n].VID;
		CellId=m_MenuCells[nVTS][n].CID;

		switch (m_csMCellBased[nVTS][nT][nCell])
		{
		case 'R':

			for (i=0,indexReplace=-1; i< m_ACell_replace.GetSize() && indexReplace==-1; i++)
			{
				if (m_ACell_replace[i].nT==nT && 
					m_ACell_replace[i].nCell==nCell &&
					m_ACell_replace[i].nVTS==nVTS &&
					m_ACell_replace[i].iDomain==MENUS)
					indexReplace=i;
			}
			if (bAlready)
			{
				m_nVOBIDsInProcess++;
				myCell.CID=1;
				myCell.VID=m_nVOBIDsInProcess;

				n=m_MenuCells[nVTS].GetSize();

				m_MenuCells[nVTS].SetAtGrow(n,myCell);
				csAux.Format(_T("     Replacing Cell # %d, VID/CID=%02d/%02d-->%02d/%02d"),nCell+1,VobId,CellId,m_nVOBIDsInProcess,1);
			}
			else
			{
				csAux.Format(_T("     Replacing Cell # %d, VID/CID=%02d/%02d"),nCell+1,VobId,CellId);
			}

			m_MenuCells[nVTS][n].bFixPointers=false;
			if (indexReplace <0)
			{
				csAux.Format(_T("     Warning: Replacing Cell not Found  # %d, VID/CID=%02d/%02d. Keeping the original one"),nCell+1,VobId,CellId);
				MyLog(csAux,ORANGE);
				m_nWarnings++;
				if (!bAlready)
				{
					m_MenuCells[nVTS][n].iMode=CELLBASED;
					m_MenuCells[nVTS][n].chMode='K';
				}
			}
			else
			{
				MyLog(csAux);
				m_MenuCells[nVTS][n].indexReplace=indexReplace;
				m_MenuCells[nVTS][n].iMode=CELLBASED;
				m_MenuCells[nVTS][n].chMode='R';
			}
			break;

		case 'B':
			if (bAlready)
			{
				m_nVOBIDsInProcess++;
				myCell.CID=1;
				myCell.VID=m_nVOBIDsInProcess;
				n=m_MenuCells[nVTS].GetSize();
				m_MenuCells[nVTS].SetAtGrow(n,myCell);
				csAux.Format(_T("     Blanking Cell # %d, VID/CID=%02d/%02d-->%02d/%02d"),nCell+1,VobId,CellId,m_nVOBIDsInProcess,1);
			}
			else
				csAux.Format(_T("     Blanking Cell # %d, VID/CID=%02d/%02d"),nCell+1,VobId,CellId);

			MyLog(csAux);
			m_MenuCells[nVTS][n].bFixPointers=false;
			m_MenuCells[nVTS][n].iMode=CELLBASED;
			m_MenuCells[nVTS][n].chMode='B';
			break;

		case 'S':
			if (bAlready)
			{
				csAux.Format(_T("     Skiping already processed cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
			}
			else
			{
				csAux.Format(_T("     Motion to still+audio Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
				m_MenuCells[nVTS][n].iMode=CELLBASED;
				m_MenuCells[nVTS][n].chMode='S';
				for (i=0, i64IFrame=-7; i< m_ACellStillinfo.GetSize() && i64IFrame ==-7; i++)
				{
					if (m_ACellStillinfo[i].nT==nT && 
						m_ACellStillinfo[i].nCell==nCell &&
						m_ACellStillinfo[i].iDomain==MENUS &&
						m_ACellStillinfo[i].nVTS==nVTS)
					{
						m_MenuCells[nVTS][n].indexStill=i;
						i64IFrame=m_ACellStillinfo[i].i64IFrame;
					}
				}
				if (i64IFrame==-7) i64IFrame=-5;
				m_MenuCells[nVTS][n].i64IFrame1=i64IFrame;
				m_MenuCells[nVTS][n].bFixPointers=false;
			}
			break;
		case 'Z':
			if (bAlready)
			{
				csAux.Format(_T("     Skiping already processed cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
			}
			else
			{
				csAux.Format(_T("     Motion to still w/o audio Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
				m_MenuCells[nVTS][n].iMode=CELLBASED;
				m_MenuCells[nVTS][n].chMode='Z';
				for (i=0, i64IFrame=-7; i< m_ACellStillinfo.GetSize() && i64IFrame ==-7; i++)
				{
					if (m_ACellStillinfo[i].nT==nT && 
						m_ACellStillinfo[i].nCell==nCell &&
						m_ACellStillinfo[i].iDomain==MENUS &&
						m_ACellStillinfo[i].nVTS==nVTS)
					{
						m_MenuCells[nVTS][n].indexStill=i;
						i64IFrame=m_ACellStillinfo[i].i64IFrame;
					}
				}
				if (i64IFrame==-7) i64IFrame=-5;
				m_MenuCells[nVTS][n].i64IFrame1=i64IFrame;
				m_MenuCells[nVTS][n].bFixPointers=false;
			}
			break;

		case 'C':
			if (bAlready)
			{
				csAux.Format(_T("     Skiping already processed cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
			}
			else
			{
				csAux.Format(_T("     Cutting Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
				m_MenuCells[nVTS][n].iMode=CELLBASED;
				m_MenuCells[nVTS][n].chMode='C';
				m_MenuCells[nVTS][n].bFixPointers=true;

				i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
				i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]);
				iIniSector=0;
				iEndSector=(int)(i64EndSec-i64IniSec);
				iIniIsClosed=iEndIsClosed=1;
				iAction=0;

				for(i=0; i< m_ACellCutinfo.GetSize(); i++)
				{
					if ( m_ACellCutinfo[i].nT== nT &&
					     m_ACellCutinfo[i].nCell== nCell &&
						 m_ACellCutinfo[i].nVTS== nVTS &&
						 m_ACellCutinfo[i].iDomain==MENUS )
					{
						if (m_ACellCutinfo[i].iEndSector>0)
							iEndSector=m_ACellCutinfo[i].iEndSector;
						if (m_ACellCutinfo[i].iIniSector>0)
							iIniSector=m_ACellCutinfo[i].iIniSector;
						iIniIsClosed=m_ACellCutinfo[i].iIniIsClosed;
						iEndIsClosed=m_ACellCutinfo[i].iEndIsClosed;
						iAction=m_ACellCutinfo[i].iAction;
					}
				}
				if (iIniSector==0 &&
				    iEndSector==(int)(i64EndSec-i64IniSec)  && iAction==0 )
				{
					// Keep Completely
					// Keep the Cell as it is
					m_MenuCells[nVTS][n].iMode=CELLBASED;
					m_MenuCells[nVTS][n].chMode='K';
					m_MenuCells[nVTS][n].bFixPointers=false;
				}
/*				else if (iIniSecCell< iEndSecCell)
				{
					// Blank the Cell 
					m_MenuCells[nVTS][n].iMode=CELLBASED;
					m_MenuCells[nVTS][n].chMode='B';
					m_MenuCells[nVTS][n].bFixPointers=false;
				}
*/
				else if (iEndSector==(int)(i64EndSec-i64IniSec) && iAction==0)
				{	//					 _______________________
					// CASE 1:			|			|			|
					//					|	DELETE	|	KEEP	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64IniSec+=iIniSector;
					i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_MenuCells[nVTS][n].iFirstIsClosedGOP=iIniIsClosed;
					m_MenuCells[nVTS][n].iCutMode=CUT1;
				}
				else if (iIniSector==0 && iAction==0)
				{	//		 			 _______________________
					// CASE 2:			|			|			|
					//					|	KEEP	|	DELETE	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=i64IniSec+iEndSector-1;
					if ( i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]))
						i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64IniSec > i64EndSec) i64EndSec=i64IniSec;
					m_MenuCells[nVTS][n].iFirstIsClosedGOP=1; // First VOBU of cell, must be closed
					m_MenuCells[nVTS][n].iCutMode=CUT2;
				}
				else if (iEndSector==(int)(i64EndSec-i64IniSec) && iAction!=0)
				{	//		 			 _______________________
					// CASE 2b:			|			|			|
					//					|	KEEP	|	DELETE	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=i64IniSec+iIniSector-1;
					if (i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]))
					   i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64IniSec > i64EndSec) i64EndSec=i64IniSec;
					m_MenuCells[nVTS][n].iFirstIsClosedGOP=1; // First VOBU of cell
					m_MenuCells[nVTS][n].iCutMode=CUT2;
				}
				else if (iIniSector==0 && iAction!=0)
				{	//		 			 _______________________
					// CASE 1b:			|			|			|
					//					|	DELETE	|	KEEP	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64IniSec+=iEndSector;
					i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_MenuCells[nVTS][n].iFirstIsClosedGOP=iEndIsClosed; 
					m_MenuCells[nVTS][n].iCutMode=CUT1;
				}
				
				else if (iAction==0)
				{	//					____________________________________
					// CASE 3:			|			|			|			|
					//					|	DELETE	|	KEEP	|	DELETE	|
					//					|___________|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec= i64IniSec+iEndSector-1;
					i64IniSec+=iIniSector;
					if ( i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]))
						i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_MenuCells[nVTS][n].iFirstIsClosedGOP=iIniIsClosed; 
					m_MenuCells[nVTS][n].iCutMode=CUT3;
				}

				else if (iAction!=0)
				{	//					____________________________________
					// CASE 4:			|			|			|			|
					//					|	KEEP	|	DELETE	|	KEEP	|
					//					|___________|___________|___________|

					// mark Endsector as iniLBa and inisector as endlba.
					// So i64EndSec will be lower than i64IniSec.

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec= i64IniSec+iIniSector-1;

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64IniSec= i64IniSec+iEndSector;
					m_MenuCells[nVTS][n].iFirstIsClosedGOP=iEndIsClosed; 
					m_MenuCells[nVTS][n].iCutMode=CUT4;
				}
				m_MenuCells[nVTS][n].i64IniSecAux=i64IniSec;
				m_MenuCells[nVTS][n].i64EndSecAux=i64EndSec;

			} // else process cell
			break;


		case 'K':
		default:
			if (bAlready)
			{
				csAux.Format(_T("     Skiping already processed cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
			}
			else
			{
				csAux.Format(_T("     Keeping Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
				m_MenuCells[nVTS][n].iMode=CELLBASED;
				m_MenuCells[nVTS][n].chMode='K';
				m_MenuCells[nVTS][n].bFixPointers=false;
			}
			break;
		}
	}
}
void CVobBlankerApp::MenuStill(int nVTS,int nT, bool bAudio)
{
	int n,nCell;
	CString csAux,csAux2;
	int nLU,nPGC;
	__int64 i64Sector;
//i64Sector values:
// -1: First GOP with buttons
// -2: Middle GOP if same # of buttons
// -3: Last GOP if same # of buttons
// -4: The largest between last, middle and first
// -5: Use Global default.
// >=0: Exact (selected) sector, relative to ini of cell.


	nLU=m_nLU_MPGC[nVTS][nT];
	nPGC=nT-m_nIniPGCinLU[nVTS][nLU];

	if (bAudio)
		csAux2="with audio";
	else
		csAux2="w/o audio";

	i64Sector=(m_iIFrameMode+1)*(-1);

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Motion2Still %s Menu LU %02d, PGC %02d"),csAux2,nLU+1,nPGC+1);
	else
		csAux.Format(_T("VTS %02d: Motion2Still %s Menu LU %02d, PGC %02d"),nVTS,csAux2,nLU+1,nPGC+1);
    MyLog(csAux);

//  Loop cell by cell 
	for (nCell=0; nCell<m_nMCells[nVTS][nT] ;nCell++)
	{
		n=MenuCellGetPos( nVTS, nT, nCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}
		if (m_MenuCells[nVTS][n].iMode==UNREF || m_MenuCells[nVTS][n].iMode==REUSE)
		{
			if (bAudio)
				m_MenuCells[nVTS][n].iMode=STILLA;
			else
				m_MenuCells[nVTS][n].iMode=STILLNA;
			if (m_bCheckBlankNoB && m_MenuCells[nVTS][n].nButtons <=0 )
			{
				csAux.Format(_T("     NOTE: Blanking Cell without buttons: Cell %d"), nCell+1);
				MyLog(csAux,CIAN15);
				m_nNotes++;
				m_MenuCells[nVTS][n].iMode=BLANK;
			}
			m_MenuCells[nVTS][n].bFixPointers=false;
		}
	}
}

///////////////////////////////////////////////////////////////////////////
///             Cell Methods, called in Second phase   ////////////////////
///////////////////////////////////////////////////////////////////////////

int CVobBlankerApp::MenuCellGetPos(int nVTS,int nT,int nCell)
{
// Returns the position in the array (from 0 to n-1). Returns -1 if not present.
	int CellId,VobId;
	int i,ii,iACells;
	bool bAlready;

	CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4+3];
	VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4]);
	iACells=m_MenuCells[nVTS].GetSize();

	for (i=0, bAlready=false; i<iACells && bAlready==false; i++)
	{
		if (m_MenuCells[nVTS][i].CID == CellId &&
			m_MenuCells[nVTS][i].VID == VobId )
		{
			bAlready=true;
			ii=i;
		}
	}
	if (bAlready==false)
		return -1;
	return ii;
}

int CVobBlankerApp::MenuCellGetPosByVCID(int nVTS, int VobId,int CellId)
{
// Returns the position in the array (from 0 to n-1). Returns -1 if not present.
	int i,ii,iACells;
	bool bAlready;

	iACells=m_MenuCells[nVTS].GetSize();

	for (i=0, bAlready=false; i<iACells && bAlready==false; i++)
	{
		if (m_MenuCells[nVTS][i].CID == CellId &&
			m_MenuCells[nVTS][i].VID == VobId )
		{
			bAlready=true;
			ii=i;
		}
	}
	if (bAlready==false)
		return -1;
	return ii;
}

void CVobBlankerApp::MenuCellKeep(int nVTS, int nCell, CWnd* pDlg)
{
	__int64 i64sectors, i64IniSec,i64EndSec,i64;
	CString csAux;
	bool bMyCell,bAlreadyNav;
	int VID,CID,NVID,NCID;
	int nPads;

	VID=m_MenuCells[nVTS][nCell].VID;
	CID=m_MenuCells[nVTS][nCell].CID;
	NVID=m_MenuCells[nVTS][nCell].NVID;
	NCID=m_MenuCells[nVTS][nCell].NCID;

	if( m_MenuCells[nVTS][nCell].iMode!=CELLBASED)
	{
		if (nVTS==0)
			csAux.Format(_T("VIDEO_TS: Keeping Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		else
			csAux.Format(_T("VTS %02d: Keeping Cell VID/CID: %02d/%02d --> %02d/%02d"),nVTS,VID,CID,NVID,NCID);
	    MyLog(csAux);
	}

//  Locate the cell
	i64sectors=0;
	i64IniSec=m_MenuCells[nVTS][nCell].i64IniSecCell;
	i64EndSec=m_MenuCells[nVTS][nCell].i64EndSecCell;

	if (nVTS==0)
		csAux="VIDEO_TS.VOB";
	else
		csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	if (m_Fin ==NULL)  
	{
		MyErrorLog_Box("Error opening input Menu VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}
	fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

	bAlreadyNav=false;
	nPads=0;
	for (i64=0,bMyCell=true;i64< (i64EndSec-i64IniSec+1) && m_bInProcess==true;i64++)
	{
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			MyErrorLog_Box("Input error: Reached end of VOB too early");
			m_bInProcess=false;
			return;
		}
		if (IsSynch(m_buffer) != true)
		{
			if (nPads==0)
				MyLog("    WARNING: Packs unsynchronized. Skipping packs...",ORANGE); 
			nPads++;
		}
		else if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				if (m_buffer[0x420]==(uchar)(VID%256) &&
					m_buffer[0x41F]==(uchar)(VID/256) &&
					m_buffer[0x422]== (uchar) CID)
					bMyCell=true;
				else
					bMyCell=false;
				if (bMyCell)
				{
					bAlreadyNav=true;
					ModifyCID (m_buffer,NVID,NCID);
					CleanILV(m_buffer);
					WritePack (m_buffer,0);
				}
			}
			else
			{
				if (bMyCell)	WritePack (m_buffer,0);
			}
		}
	}
	if (m_Fin !=NULL) fclose (m_Fin); 

	if (!bAlreadyNav)
	{
		MyLog("    WARNING: No Navs found!: outputting a blank cell",ORANGE); 
		m_nWarnings++;
		OutputBlankCell(nVTS,NVID,NCID);
	}
	if (nPads!=0)
	{
		csAux.Format(_T("    A total of %d packs have been skipped"),nPads);
		MyLog(csAux,ORANGE);
	}
}

void CVobBlankerApp::MenuCellBlank(int nVTS,int nCell, CWnd* pDlg)
{
	CString csAux;
	int VID,CID,NVID,NCID;

	VID=m_MenuCells[nVTS][nCell].VID;
	CID=m_MenuCells[nVTS][nCell].CID;
	NVID=m_MenuCells[nVTS][nCell].NVID;
	NCID=m_MenuCells[nVTS][nCell].NCID;

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Blanking Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
	else
		csAux.Format(_T("VTS %02d: Blanking Cell VID/CID: %02d/%02d --> %02d/%02d"),nVTS,VID,CID,NVID,NCID);
    MyLog(csAux);

	OutputBlankCell(0, NVID, NCID);

}


void CVobBlankerApp::MenuCellUnref(int nVTS,int nCell, CWnd* pDlg)
{
	CString csAux;
	int VID,CID,NVID,NCID;

	VID=m_MenuCells[nVTS][nCell].VID;
	CID=m_MenuCells[nVTS][nCell].CID;
	NVID=m_MenuCells[nVTS][nCell].NVID;
	NCID=m_MenuCells[nVTS][nCell].NCID;

/*	if (!m_bCheckVobMUnref)
	{
		if (nVTS==0)
			csAux.Format(_T("VIDEO_TS: Deleting unref Cell VID/CID: %02d/%02d"),VobId,CellId);
		else
			csAux.Format(_T("VTS %02d: Deleting unref Cell VID/CID: %02d/%02d"),nVTS,VobId,CellId);
		MyLog(csAux);
		return;
	}
*/
	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Blanking unref Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
	else
		csAux.Format(_T("VTS %02d: Blanking unref Cell VID/CID: %02d/%02d --> %02d/%02d"),nVTS,VID,CID,NVID,NCID);
    MyLog(csAux);

	OutputBlankCell(0, NVID, NCID);

}

void CVobBlankerApp::MenuCellCut(int nVTS,int nCell, CWnd* pDlg)
{

	int VID,CID,NVID,NCID;
	__int64 i64;
	__int64 i64IniSec,i64EndSec,i64IniCut,i64EndCut;
	__int64 i64IniCut1,i64EndCut1,i64IniCut2,i64EndCut2;
	CString csAux;
	bool bAlreadyNav;
	bool bLookForFirstVideo;
	bool bMyCell;
	int iFirstIsClosedGOP,iFixDuration1,iFixDuration2;
	bool bTwoPasses;
	int nNavs;
	int nPads;


//  Locate the cell
	i64IniSec=m_MenuCells[nVTS][nCell].i64IniSecCell;
	i64EndSec=m_MenuCells[nVTS][nCell].i64EndSecCell;
	i64IniCut=m_MenuCells[nVTS][nCell].i64IniSecAux;
	i64EndCut=m_MenuCells[nVTS][nCell].i64EndSecAux;
	iFirstIsClosedGOP=m_MenuCells[nVTS][nCell].iFirstIsClosedGOP;

	VID=m_MenuCells[nVTS][nCell].VID;
	CID=m_MenuCells[nVTS][nCell].CID;
	NVID=m_MenuCells[nVTS][nCell].NVID;
	NCID=m_MenuCells[nVTS][nCell].NCID;

	if( m_MenuCells[nVTS][nCell].iMode!=CELLBASED)
	{
		csAux.Format(_T("VTS %02d: Cutting Cell VID/CID: %02d/%02d --> %02d/%02d"),
			nVTS,VID,CID,NVID,NCID);
		MyLog(csAux);
	}


	if (i64EndCut==i64IniCut)
	{
		MyLog("    WARNING: Ini and end mark are the same: outputting a blank cell",ORANGE); 
		m_nWarnings++;
		OutputBlankCell(nVTS,NVID,NCID);
		return;
	}

	//					________________________
	// CASE 1:			|			|			|
	//					|	DELETE	|	KEEP	|
	//					|___________|___________|
	//					________________________
	// CASE 2:			|			|			|
	//					|	KEEP	|	DELETE	|
	//					|___________|___________|
	//					____________________________________
	// CASE 3:			|			|			|			|
	//					|	DELETE	|	KEEP	|	DELETE	|
	//					|___________|___________|___________|
	//					____________________________________
	// CASE 4:			|			|			|			|
	//					|	KEEP	|	DELETE	|	KEEP	|
	//					|___________|___________|___________|

	if (i64EndCut > i64IniCut)
	{
// CASES 1, 2 & 3;
		if (i64IniCut!= i64IniSec) 
		{
			// CASE 1 & 3
			iFixDuration1=GETOFFDURATION;
			bLookForFirstVideo=true;
		}
		else
		{
			// CASE 2
			iFixDuration1=0;
			bLookForFirstVideo=false;
		}
		i64EndCut1=i64EndCut;
		i64IniCut1=i64IniCut;
		bTwoPasses=false;

	}
	else
	{
// CASE 4;
		bLookForFirstVideo=false;
		i64IniCut1=i64IniSec;
		i64EndCut1=i64EndCut;
		iFixDuration1=SAVEOFFDURATION;

// Second pass always looks for first video.
		i64IniCut2=i64IniCut;
		i64EndCut2=i64EndSec;
		iFixDuration2=CALCULATE_FIXOFFDURATION;
		bTwoPasses=true;
	}

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS.VOB"));
	else
		csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	fseek(m_Fin, (long) (i64IniCut1*2048), SEEK_SET);

	// Guarantee to start with a Nav Pack
	bAlreadyNav=false;
	m_iFixDuration=iFixDuration1;
	nNavs=0;
	nPads=0;
	for (i64=0,bMyCell=true;i64< (i64EndCut1-i64IniCut1+1) && i64EndCut1!=i64IniCut1 && m_bInProcess==true;i64++)
	{
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			MyErrorLog_Box("Input error: Reached end of VOB");
			m_bInProcess=false;
			return;
		}
		if (IsSynch(m_buffer) != true)
		{
			if (nPads==0)
				MyLog("    WARNING: Packs unsynchronized. Skipping packs...",ORANGE); 
			nPads++;
		}
		else if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				if (m_buffer[0x420]==(uchar)(VID%256) &&
					m_buffer[0x41F]==(uchar)(VID/256) &&
					m_buffer[0x422]== (uchar) CID)
					bMyCell=true;
				else
					bMyCell=false;

				if (bMyCell)
				{
					ModifyCID (m_buffer,NVID, NCID);
					bAlreadyNav=true;
					nNavs++;
					WritePack (m_buffer,nVTS);
				}
			}
			else
			{
				if (bMyCell && bAlreadyNav)
				{
					if (bLookForFirstVideo && iFirstIsClosedGOP==0 && IsVideo(m_buffer) )
					{
						bLookForFirstVideo=false;
						SetBreakGOP(m_buffer);
					}
					WritePack (m_buffer,nVTS);
				}
			}
		}
	}


	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;

	if (!bTwoPasses) 
	{
		if (nNavs ==0)
		{
			MyLog("    WARNING: No Navs found!: outputting a blank cell",ORANGE); 
			m_nWarnings++;
			OutputBlankCell(nVTS,NVID,NCID);
		}
		if (nPads!=0)
		{
			csAux.Format(_T("    A total of %d packs have been skipped"),nPads);
			MyLog(csAux,ORANGE);
		}
		return;
	}
// Second pass	
	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS.VOB"), nVTS);
	else
		csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	fseek(m_Fin, (long) (i64IniCut2*2048), SEEK_SET);

	// Guarantee to start with a Nav Pack
	bAlreadyNav=false;
	bLookForFirstVideo=true;  //always in second pass
	m_iFixDuration=iFixDuration2;


	for (i64=0,bMyCell=true;i64< (i64EndCut2-i64IniCut2+1) && i64EndCut2!=i64IniCut2 && m_bInProcess==true;i64++)
	{
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			MyErrorLog_Box("Input error: Reached end of VOB");
			m_bInProcess=false;
			return;
		}
		if (IsSynch(m_buffer) != true)
		{
			if (nPads==0)
				MyLog("    WARNING: Packs unsynchronized. Skipping packs...",ORANGE); 
			nPads++;
		}
		else if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				if (m_buffer[0x420]==(uchar)(VID%256) &&
					m_buffer[0x41F]==(uchar)(VID/256) &&
					m_buffer[0x422]== (uchar) CID)
					bMyCell=true;
				else
					bMyCell=false;

				if (bMyCell)
				{
					ModifyCID (m_buffer,NVID, NCID);
					bAlreadyNav=true;
					nNavs++;
					WritePack (m_buffer,nVTS);
				}
			}
			else
			{
				if (bMyCell && bAlreadyNav)
				{
					if (bLookForFirstVideo && iFirstIsClosedGOP==0 && IsVideo(m_buffer) )
					{
						bLookForFirstVideo=false;
						SetBreakGOP(m_buffer);
					}
					WritePack (m_buffer,nVTS);
				}
			}
		}
	}
	if (nNavs ==0)
	{
		MyLog("    WARNING: No Navs found!: outputting a blank cell",ORANGE); 
		m_nWarnings++;
		OutputBlankCell(nVTS,NVID,NCID);
	}
	if (nPads!=0)
	{
		csAux.Format(_T("    A total of %d packs have been skipped"),nPads);
		MyLog(csAux,ORANGE);
	}
	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;
}


void CVobBlankerApp::MenuCellBasedCell(int nVTS,int nCell, CWnd* pDlg)
{
	int k;
	CString csAux,csVTS;
	int VID,CID,NVID,NCID;
	int	OldVobId,OldCellId;
	__int64 i64,i64CellLBA;
	struct  _stati64 statbuf;
	DWORD dwVOBUDuration;
	bool bWarning;

	VID=m_MenuCells[nVTS][nCell].VID;
	CID=m_MenuCells[nVTS][nCell].CID;
	NVID=m_MenuCells[nVTS][nCell].NVID;
	NCID=m_MenuCells[nVTS][nCell].NCID;


	if (nVTS==0)
		csVTS.Format(_T("VIDEO_TS: (CB) "));
	else
		csVTS.Format(_T("VTS %02d: (CB) "),nVTS);

	switch (m_MenuCells[nVTS][nCell].chMode)
	{
	case 'R':
		csAux.Format(_T("Replacing Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		MyLog(csVTS+csAux);

		m_csFin=m_ACell_replace[m_MenuCells[nVTS][nCell].indexReplace].csPath;

		m_Fin=NULL;
		if (! (m_csFin.IsEmpty()) )  m_Fin=fopen(m_csFin,"rb");

		if (m_Fin ==NULL)
		{
			MyErrorLog_Box("Error opening input VOB: " + m_csFin);
			m_bInProcess=false;
			return;
		}

		if (_stati64 ( m_csFin, &statbuf)==0)
			i64CellLBA=statbuf.st_size/2048;

		OldCellId=OldVobId=-1;		
		bWarning=false;

	// Seems compatible with ADDOFFDURATION...
		if (m_bCheckElapsed) m_iFixDuration=GETOFFDURATION;

		for (i64=0 ; i64<i64CellLBA && m_bInProcess==true ; i64++)
		{
			if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				if (m_Fin !=NULL) { fclose(m_Fin); m_Fin=NULL;}
				return;
			}
			if (IsSynch(m_buffer) != true)
			{
				MyErrorLog_Box("Error reading input VOB: Unsynchronized");
				m_bInProcess=false;
				if (m_Fin !=NULL) { fclose(m_Fin); m_Fin=NULL;}
				return;
			}
			if (m_bInProcess==true)
			{
				if (IsNav(m_buffer))
				{
					if (OldVobId==-1)
					{
						OldVobId=GetNbytes(2,&m_buffer[0x41F]);
						OldCellId=m_buffer[0x422];
					}
					else
					{
						if (OldVobId!=(int)GetNbytes(2,&m_buffer[0x41F]) || 
							OldCellId!=m_buffer[0x422])
						{
						// A new Cell has been detected
							OldVobId=GetNbytes(2,&m_buffer[0x41F]);
							OldCellId=m_buffer[0x422];
							if (!bWarning)
							{
								bWarning=true;
								MyLog("     WARNING: Number of Cells in replacing VOB higher than one. Continuing with same cell VID/CID",ORANGE);
								m_nWarnings++;
							}
							k=m_ANavinfo.GetSize()-1;
							if (k>=0)
							{
								m_iFixDuration=ADDOFFDURATION;
								m_dwOffDuration=m_ANavinfo[k].dwDuration;
								dwVOBUDuration=(m_ANavinfo[k].iPTS1-m_ANavinfo[k].iPTS0)/(m_ticsperframe);
								dwVOBUDuration=Dec2BCD(dwVOBUDuration);
								dwVOBUDuration=dwVOBUDuration|(m_dwOffDuration & 0xc0);
								m_dwOffDuration=AddDuration(m_dwOffDuration,dwVOBUDuration);
							}
						}
					}
					ModifyCID (m_buffer,NVID, NCID);
					CleanILV(m_buffer);
				}
				WritePack(m_buffer,0);
			}
		}
		if (m_Fin !=NULL) { fclose(m_Fin); m_Fin=NULL;}
		break;
	case 'B':
		csAux.Format(_T("Blanking Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		MyLog(csVTS+csAux);

		OutputBlankCell(0, NVID, NCID);
		break;
	case 'S':
		csAux.Format(_T("Motion2still with audio VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		MyLog(csVTS+csAux);
		MenuCellStill(nVTS, nCell,true, m_MenuCells[nVTS][nCell].i64IFrame1, pDlg);
		break;
	case 'Z':
		csAux.Format(_T("Motion2still w/o audio VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		MyLog(csVTS+csAux);
		MenuCellStill(nVTS, nCell,false, m_MenuCells[nVTS][nCell].i64IFrame1, pDlg);
		break;
	case 'C':
		csAux.Format(_T("Cutting Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		MyLog(csVTS+csAux);
		MenuCellCut(nVTS,nCell,pDlg);
		break;
	case 'K':
	default:
		csAux.Format(_T("Keeping Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		MyLog(csVTS+csAux);

		MenuCellKeep(nVTS,nCell, pDlg);
		break;
	}
}

///////////////////////////////////////////////////////////////////////////
///             Cell Methods, called in Second phase   ////////////////////
///             Motion 2 Still methods                 ////////////////////
///////////////////////////////////////////////////////////////////////////

int CVobBlankerApp::ExtractExternalIFrame(__int64 i64Sector)
{
// Returns the number of sectors of the m_IFrame
	__int64 i64;
	int iEnd;
	int i, j, iFindex, iEndIFrame;
	int start,nbytes;
	bool bFirstVideo, bNav;
	CString csAux;


// Extract the I-Frame
	fseek(m_Fin, (long) ((i64Sector)*2048), SEEK_SET);
	bNav=false;
	while (bNav==false)
	{
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			MyErrorLog_Box("Input error: Reached end of VOB too early");
			return -1;
		}
			if (IsSynch(m_buffer) != true)
		{
			MyErrorLog_Box("Error reading input VOB: Unsynchronized");
			return -1;
		}
		if (IsNav(m_buffer)) bNav=true;
	}

	iEnd=GetNbytes(4,&m_buffer[0x413]);

	m_IFrame= new uchar[(iEnd+1)*2048];

	iFindex=0;
	iEndIFrame=0;
	bFirstVideo=true;
	for (i64=0; i64< iEnd ; i64++)
	{
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			MyErrorLog_Box("Input error: Reached end of VOB too early");
			delete [] m_IFrame;
			return -1;
		}
		if (IsVideo(m_buffer))
		{
			start=0x17+m_buffer[0x16];
			nbytes=m_buffer[0x12]*256+m_buffer[0x13]+0x14-start;
			for (i=0;i<2048;i++)
			{
				m_IFrame[iFindex+i]=m_buffer[i];
			}
			if (bFirstVideo)
			{
				bFirstVideo=false;
				// Reset temperal sequence 
				for (j=start; j<2044 ; j++)
					if (m_IFrame[j]   == 0 && m_IFrame[j+1] == 0 && 
						m_IFrame[j+2] == 1 && m_IFrame[j+3] == 0 )
					{
						m_IFrame[j+4]=0;
						m_IFrame[j+5]=m_IFrame[j+5] & 0x3F;
						j=2048;
					}
	
			}
			if (i64==(iEnd-1))
			{
				for (j=start,iEndIFrame=0; j<2048-3; j++)
				{
					if (m_buffer[j]   == 0 && m_buffer[j+1] == 0 &&
						m_buffer[j+2] == 1 && ( m_buffer[j+3] == 0 || m_buffer[j+3] == 0xB7 ) )
						 
					{
						iEndIFrame=j;
						Put4bytes(0x000001B7, &m_IFrame[iFindex+iEndIFrame]);
						if ((iEndIFrame+4)<(2048-6))
						{
							Put4bytes(0x000001BE, &m_IFrame[iFindex+iEndIFrame+4]);
							Put2bytes(2048-iEndIFrame-6-4, &m_IFrame[iFindex+iEndIFrame+8]);
							for (i=iEndIFrame+6+4; i<2048; i++)
								m_IFrame[iFindex+i]=0xFF;
						}
						else
						{
							for (i=iEndIFrame+4; i<2048; i++)
								m_IFrame[iFindex+i]=0x00;
						}
						Put2bytes(iEndIFrame+4-0x14, &m_IFrame[iFindex+0x12]);
						j=2048;
					}
				}
				if (!iEndIFrame )
				{
					csAux.Format(_T("     WARNING: No picture sequence found in external VOBU. Adding a New pack."));
					MyLog(csAux,ORANGE);
					m_nWarnings++;
					// Add a full padd pack
					iFindex+=2048;
					for (i=0;i<64;i++)
						m_IFrame[iFindex+i]=EndSeqPlusPadding[i];
					for (i=64;i<2048;i++)
						m_IFrame[iFindex+i]=0xFF;
				}
			}
			iFindex+=2048;
		}
	}
	return iFindex/2048;
}

int CVobBlankerApp::ExtractMenuIFrame(int nVTS, int nCell, __int64 i64Sector)
{
// Returns the number of sectors of the m_IFrame
	__int64 i64sectors, i64IniSec,i64EndSec,i64;
	int VobId,CellId;
	int iEnd;
	int i, j, iFindex, iEndIFrame;
	int start,nbytes;
	bool bFirstVideo;
	CString csAux;

//  Locate the menu cell
	i64sectors=0;
	i64IniSec=m_MenuCells[nVTS][nCell].i64IniSecCell;
	i64EndSec=m_MenuCells[nVTS][nCell].i64EndSecCell;
	VobId=m_MenuCells[nVTS][nCell].VID;
	CellId=m_MenuCells[nVTS][nCell].CID;


// Extract the I-Frame
	fseek(m_Fin, (long) ((i64IniSec-i64sectors+i64Sector)*2048), SEEK_SET);
	if (readbuffer(m_buffer,m_Fin)!=2048)
	{
		MyErrorLog_Box("Input error: Reached end of VOB too early");
		return -1;
	}
		if (IsSynch(m_buffer) != true)
	{
		MyErrorLog_Box("Error reading input VOB: Unsynchronized");
		return -1;
	}
	if (!IsNav(m_buffer))
	{
		MyErrorLog_Box("Input error: Not found a nav pack where it should be");
		return -1;
	}

	iEnd=GetNbytes(4,&m_buffer[0x413]);

	m_IFrame= new uchar[(iEnd+1)*2048];

	iFindex=0;
	iEndIFrame=0;
	bFirstVideo=true;
	for (i64=0; i64< iEnd ; i64++)
	{
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			MyErrorLog_Box("Input error: Reached end of VOB too early");
			delete [] m_IFrame;
			return -1;
		}
		if (IsVideo(m_buffer))
		{
			start=0x17+m_buffer[0x16];
			nbytes=m_buffer[0x12]*256+m_buffer[0x13]+0x14-start;
			for (i=0;i<2048;i++)
			{
				m_IFrame[iFindex+i]=m_buffer[i];
			}
			if (bFirstVideo)
			{
				bFirstVideo=false;
				// Reset temperal sequence 
				for (j=start; j<2044 ; j++)
					if (m_IFrame[j]   == 0 && m_IFrame[j+1] == 0 && 
						m_IFrame[j+2] == 1 && m_IFrame[j+3] == 0 )
					{
						m_IFrame[j+4]=0;
						m_IFrame[j+5]=m_IFrame[j+5] & 0x3F;
						j=2048;
					}
	
			}
			if (i64==(iEnd-1))
			{
				for (j=start,iEndIFrame=0; j<2048-3; j++)
				{
					if (m_buffer[j]   == 0 && m_buffer[j+1] == 0 &&
						m_buffer[j+2] == 1 && ( m_buffer[j+3] == 0 || m_buffer[j+3] == 0xB7 ) )
						 
					{
						iEndIFrame=j;
						Put4bytes(0x000001B7, &m_IFrame[iFindex+iEndIFrame]);
						if ((iEndIFrame+4)<(2048-6))
						{
							Put4bytes(0x000001BE, &m_IFrame[iFindex+iEndIFrame+4]);
							Put2bytes(2048-iEndIFrame-6-4, &m_IFrame[iFindex+iEndIFrame+8]);
							for (i=iEndIFrame+6+4; i<2048; i++)
								m_IFrame[iFindex+i]=0xFF;
						}
						else
						{
							for (i=iEndIFrame+4; i<2048; i++)
								m_IFrame[iFindex+i]=0x00;
						}
						Put2bytes(iEndIFrame+4-0x14, &m_IFrame[iFindex+0x12]);
						j=2048;
					}
				}
				if (!iEndIFrame )
				{
					csAux.Format(_T("     WARNING: No picture sequence found in selected VOBU of cell %d. Adding a New pack."),nCell+1);
					MyLog(csAux,ORANGE);
					m_nWarnings++;
					// Add a full padd pack
					iFindex+=2048;
					for (i=0;i<64;i++)
						m_IFrame[iFindex+i]=EndSeqPlusPadding[i];
					for (i=64;i<2048;i++)
						m_IFrame[iFindex+i]=0xFF;
				}
			}
			iFindex+=2048;
		}
	}
	return iFindex/2048;
}

void CVobBlankerApp::MenuCellStill(int nVTS, int nCell, bool bAudio, __int64 i64Sector, CWnd* pDlg)
{
	int i,j,k,l;
	__int64 i64IniSec,i64EndSec,i64;
	CString csAux,csAux2;
	bool bMyCell;
	int VID,CID,NVID,NCID;
	__int64 i64auxp1,i64auxp2;
	int ilastpack, ilastpack_old;
	bool bFirstVobu, bLastVobu;
	int nPacksIFrame;
	uint64 scr,scr_new;
	int nInserted,nToBeInserted;
	bool bInserting;
	int scr_ext;
	int iFormat, iVideoAttr;
	UINT vobu_s_ptm,vobu_e_ptm,vobu_se_e_ptm, videopts, videodts;
//	__int64 VOBUSector, i64LastSector;
	__int64 i64SecIniButtons,i64SecEndButtons,i64SecMidButtons,i64SecMaxButtons;
//	int EndADMAPSector;
//	int nPacksStart,nPacksEnd;
	int nAud[8],iAud;
	int nPacksWritten;
	__int64 i64SubP;
	bool bSubsWarned, bSecondVobu;
	int	nbytes,iSubsStart,nIndex, nNewIndex,nBlocks,nSize;
	uchar mySubs[64000];
	int nSubId;
	int nPreSubs,nPostSubs,ipack;
	long iPosition;
	uchar t_buffer[2050];
	bool bExternalFile;
	int nButtons;

	bExternalFile=false;

//i64Sector values:
// -1: First GOP with buttons
// -2: Middle GOP if same # of buttons
// -3: Last GOP if same # of buttons
// -4: The largest between last, middle and first
// -5: Use global default.
// >=0: Exact (selected) sector, relative to ini of cell.
// -6: External File

	if (i64Sector==-5) i64Sector=(m_iIFrameMode+1)*(-1);

//  Locate the menu cell
//	i64sectors=0;
	i64IniSec=m_MenuCells[nVTS][nCell].i64IniSecCell;
	i64EndSec=m_MenuCells[nVTS][nCell].i64EndSecCell;
	VID=m_MenuCells[nVTS][nCell].VID;
	CID=m_MenuCells[nVTS][nCell].CID;
	NVID=m_MenuCells[nVTS][nCell].NVID;
	NCID=m_MenuCells[nVTS][nCell].NCID;


	if( m_MenuCells[nVTS][nCell].iMode!=CELLBASED)
	{
		if (bAudio)
			csAux2="with";
		else
			csAux2="w/o";

		if (nVTS==0)
			csAux.Format(_T("VIDEO_TS: Motion2still %s audio Cell VID/CID: %02d/%02d --> %02d/%02d"),csAux2,VID,CID,NVID,NCID);
		else
			csAux.Format(_T("VTS %02d: Motion2still %s audio Cell VID/CID: %02d/%02d --> %02d/%02d"),nVTS,csAux2,VID,CID,NVID,NCID);
		MyLog(csAux);
	}

// Selecting the I-Frame
	i64SecIniButtons=m_MenuCells[nVTS][nCell].i64IniButtons/2048 - i64IniSec;
	i64SecMidButtons=m_MenuCells[nVTS][nCell].i64MidButtons/2048 - i64IniSec;
	i64SecEndButtons=m_MenuCells[nVTS][nCell].i64EndButtons/2048 - i64IniSec;
	if (i64Sector==-1)
		i64Sector=i64SecIniButtons;

	if (i64Sector==-2)
	{
		if (m_MenuCells[nVTS][nCell].i64MidIFSize != 0)
			i64Sector=i64SecMidButtons;
		else
			i64Sector=i64SecIniButtons;
	}
	if (i64Sector==-3)
	{
		if (m_MenuCells[nVTS][nCell].i64EndIFSize != 0)
			i64Sector=i64SecEndButtons;
		else
			i64Sector=i64SecIniButtons;
	}
	if (i64Sector==-4)
	{
		if (m_bMaxIframeScan[nVTS]==false)
		{
			MyLog("     NOTE: Deeply scanning Menu Cells: Finding Largest IFrames" ,CIAN15 );
			m_nNotes++;
			GetMaxIFrameData(nVTS);
			m_bMaxIframeScan[nVTS]=true;
			MyLog("           Done."  );

		}

		if (m_MenuCells[nVTS][nCell].i64MaxIFSize > m_MenuCells[nVTS][nCell].i64IniIFSize )
		{
			i64SecMaxButtons=m_MenuCells[nVTS][nCell].i64MaxButtons/2048 - i64IniSec;
			i64Sector=i64SecMaxButtons;
		}
		else
			i64Sector=i64SecIniButtons;
	}
	if (i64Sector==-6)
	{
		i64Sector=0;
		bExternalFile=true;
	}

	csAux.Format(_T("     NOTE: Selected sector (relative to cell start) %I64d in cell: %d"),i64Sector,nCell+1 );
	MyLog(csAux,CIAN15);
	m_nNotes++;

///////////////////////////////////////////////////////////////////////////
// Extracting the I-Frame
///////////////////////////////////////////////////////////////////////////
	if (bExternalFile)
	{
		m_csFin=m_ACellStillinfo[m_MenuCells[nVTS][nCell].indexStill].csFileStill;
// Open External file
		m_Fin=fopen(m_csFin,"rb");
		if (m_Fin ==NULL)
		{
			MyErrorLog_Box("Error opening input VOB: "+m_csFin);
			m_bInProcess=false;
			return;
		}
		fseek(m_Fin, (long) (i64Sector*2048), SEEK_SET);
		nPacksIFrame=ExtractExternalIFrame(i64Sector);
	}
	else
	{
// Open menu file	

		if (nVTS==0)
			csAux="VIDEO_TS.VOB";
		else
			csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);	
		m_csFin=m_csInputPath+ '\\' +csAux;
		m_Fin=fopen(m_csFin,"rb");
		if (m_Fin ==NULL)
		{
			MyErrorLog_Box("Error opening input VOB: "+m_csFin);
			m_bInProcess=false;
			return;
		}
		nPacksIFrame=ExtractMenuIFrame(nVTS, nCell,i64Sector);
	}

	if (nPacksIFrame<0)
	{
		MyErrorLog_Box("Extracting IFrame process failed: Aborting");
		m_bInProcess=false;
		if (m_Fin !=NULL) fclose (m_Fin); 
		return;
	}
	if (nPacksIFrame==0)
	{
		csAux.Format(_T("     WARNING: No I Frame found in cell: %d"),nCell+1);
		MyLog(csAux,ORANGE);
		m_nWarnings++;
	}

	if (bAudio && i64SecIniButtons !=0) 
	{
		csAux.Format(_T("     WARNING: Truncating audio. Buttons start in the middle of cell: %d"),nCell+1);
		MyLog(csAux,ORANGE);
		m_nWarnings++;
	}
// Mark as closed GOP
	SetClosedGOP(m_IFrame);

//////////////////////////////////////////////////////////////////////
// Rewind
//////////////////////////////////////////////////////////////////////
	fclose(m_Fin);
	if (nVTS==0)
		csAux="VIDEO_TS.VOB";
	else
		csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);	
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	fseek(m_Fin, (long) (m_MenuCells[nVTS][nCell].i64IniButtons), SEEK_SET);

	if (bAudio) MyLog("     Opened cell for reading: All Navs have to be corrected, so this will take a while...");

	bFirstVobu=true;
	bLastVobu=false;
	bSecondVobu=false;
	bSubsWarned=false;
	ilastpack=ilastpack_old=0;
	nPacksWritten=0;

////////////////////////////////////////////////////////////////////////
// Read complete VOBUs, starting in the first one with buttons
// i64SecIniButtons is i64IniButtons which point to the fisrt pack if no buttons
// and to the first pack with buttons if there are buttons in the cell.	
//
	for (i64=i64SecIniButtons,bMyCell=true;i64< (i64EndSec-i64IniSec+1) && m_bInProcess==true;i64+=(ilastpack+1))
	{
		if ((i64%MODUPDATEVOBU) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
//////////////////////////////////////////////////////////////////////////
// Read the NAV pack
////////////////////////////////////////////////////////////////7
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			MyErrorLog_Box("Input error: Reached end of VOB too early");
			m_bInProcess=false;
			delete [] m_IFrame;
			if (m_Fin !=NULL) fclose (m_Fin); 
			return;
		}
		if (IsSynch(m_buffer) != true)
		{
			MyErrorLog_Box("Error reading input VOB: Unsynchronized");
			m_bInProcess=false;
			delete [] m_IFrame;
			if (m_Fin !=NULL) fclose (m_Fin); 
			return;
		}
		if (!IsNav(m_buffer))
		{
			MyErrorLog_Box("Input error: Not found a nav pack where it should be");
			m_bInProcess=false;
			delete [] m_IFrame;
			if (m_Fin !=NULL) fclose (m_Fin); 
			return;
		}

		nButtons=m_buffer[0x9E];

		ilastpack_old=ilastpack;
		ilastpack= GetNbytes(4,&m_buffer[0x40f]);
		if ((ilastpack+i64+1) >= (i64EndSec-i64IniSec+1)) 
			bLastVobu=true;
		if (bFirstVobu)
		{
			nPreSubs= m_MenuCells[nVTS][nCell].nPreSubs;
			nPostSubs=m_MenuCells[nVTS][nCell].nPostSubs;
			nButtons= m_buffer[0x9E];
		}
		else
			nPreSubs=nPostSubs=0;

		if (ilastpack+nPreSubs+nPostSubs >= MAXPACKSPERVOBU-1 )
		{
			MyErrorLog_Box("Input error: VOBU too large");
			m_bInProcess=false;
			delete [] m_IFrame;
			if (m_Fin !=NULL) fclose (m_Fin); 
			return;
		}
////////////////////////////////////////////////////////////////////////
/// if first VOBU....
// Read the previous VOBUs (up to 2) if there are subs in previous Vobus
//		(IniButtons is not the first VOBU in the Cell) 
//		Get the scr from its Nav
//      Read the subs, but no more packs
//      PreButtons is loaded with LBA of PreVOBU or PrePreVOBU (See GetButtonsData)
//      nPreSubs has the number of sub packs in the 2 previous packs
//      The number of packs to be read is (IniButtons-PreButtons)/2048	
//      Store only the subs of the previous VOBU 		.		      
/////////////////////////////////////////////////////////////////////////
		if (bFirstVobu && nPreSubs!=0)
		{
			fseek(m_Fin, (long) (m_MenuCells[nVTS][nCell].i64PreButtons), SEEK_SET);
			if (readbuffer(t_buffer,m_Fin)!=2048 || !IsNav(t_buffer))
			{
				MyErrorLog_Box("Input error trying to get previous VOBU");
				m_bInProcess=false;
				delete [] m_IFrame;
				if (m_Fin !=NULL) fclose (m_Fin); 
				return;
			}

			scr=readscr(t_buffer); // reads nav scr...
			scr_ext=readscr_ext(t_buffer); // reads nav scr_ext...
			writescr(scr,scr_ext, &m_buffer[0]); //writes the old src in m_buffer
// Modified: May be Prebuttons point to two VOBUs before, so ipack cannot be taken from tha NAV
//			ipack= GetNbytes(4,&t_buffer[0x40f])-1;
			ipack=(int)(m_MenuCells[nVTS][nCell].i64IniButtons-m_MenuCells[nVTS][nCell].i64PreButtons)/2048;
			for (j=1,k=1 ; j<ipack && m_bInProcess; j++)
			{
				if (readbuffer(t_buffer,m_Fin)!=2048)
				{
					MyErrorLog_Box("Input error: Reached end of VOB too early");
					m_bInProcess=false;
					delete [] m_IFrame;
					if (m_Fin !=NULL) fclose (m_Fin); 
					return;
				}
				if (IsSynch(t_buffer) != true)
				{
					MyErrorLog_Box("Error reading input VOB: Unsynchronized");
					m_bInProcess=false;
					delete [] m_IFrame;
					if (m_Fin !=NULL) fclose (m_Fin); 
					return;
				}
				if (IsSubs(t_buffer))
				{
					for (l=0;l<2048;l++)
						m_buffer[2048*k+l]=t_buffer[l];
					k++;
				}
			}
			nPreSubs=k;
// Go to the same place
			fseek(m_Fin, (long) (m_MenuCells[nVTS][nCell].i64IniButtons+2048), SEEK_SET);
		}
		else nPreSubs=0;
/////////////////////////////////////////////////////////////////////////
// Read the selected VOBU (The Nav is already in m_buffer[0]
/////////////////////////////////////////////////////////////////////////
		for (j=nPreSubs+1 ; j<ilastpack+nPreSubs+1 && m_bInProcess; j++)
		{
			if (readbuffer(&m_buffer[2048*j],m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				delete [] m_IFrame;
				if (m_Fin !=NULL) fclose (m_Fin); 
				return;
			}
			if (IsSynch(&m_buffer[2048*j]) != true)
			{
				MyErrorLog_Box("Error reading input VOB: Unsynchronized");
				m_bInProcess=false;
				delete [] m_IFrame;
				if (m_Fin !=NULL) fclose (m_Fin); 
				return;
			}
		}
/////////////////////////////////////////////////////////////////////////
// Read the next VOBU if subs exist and no audio mode
// If audio mode, subs are written anyway...
/////////////////////////////////////////////////////////////////////////
		if (bFirstVobu && nPostSubs!=0 && !bAudio)
		{
			iPosition=ftell(m_Fin);
			if (readbuffer(t_buffer,m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error trying to get next VOBU");
				m_bInProcess=false;
				delete [] m_IFrame;
				if (m_Fin !=NULL) fclose (m_Fin); 
				return;
			}
			ipack= GetNbytes(4,&t_buffer[0x40f]);
			for (j=1,k=ilastpack+nPreSubs+1 ; j<ipack+1 && m_bInProcess; j++)
			{
				if (readbuffer(t_buffer,m_Fin)!=2048)
				{
					MyErrorLog_Box("Input error: Reached end of VOB too early");
					m_bInProcess=false;
					delete [] m_IFrame;
					if (m_Fin !=NULL) fclose (m_Fin); 
					return;
				}
				if (IsSynch(t_buffer) != true)
				{
					MyErrorLog_Box("Error reading input VOB: Unsynchronized");
					m_bInProcess=false;
					delete [] m_IFrame;
					if (m_Fin !=NULL) fclose (m_Fin); 
					return;
				}
				if (IsSubs(t_buffer))
				{
					for (l=0;l<2048;l++)
						m_buffer[2048*k+l]=t_buffer[l];
					k++;
				}
			}
			nPostSubs=k;
// Recover original position
			fseek(m_Fin, iPosition, SEEK_SET);
		}
		else nPostSubs=0;

///////////////////////////////////////////////////////////////////
// Hack original length
///////////////////////////////////////////////////////////////////
		
		ilastpack=ilastpack+nPreSubs+nPostSubs;

///////////////////////////////////////////////////////////////////
//Adjust Nav pointers
///////////////////////////////////////////////////////////////////
// lastpack
//		i64auxp1=GetNbytes(4,&m_buffer[0x40f]);
// first,second and third ref end
//		i64auxp2=GetNbytes(4,&m_buffer[0x413]);
//		i64auxp3=GetNbytes(4,&m_buffer[0x417]);
//		i64auxp4=GetNbytes(4,&m_buffer[0x41B]);

		if (!bFirstVobu)
		{
			i64auxp1=0;
			Put4bytes(0,&m_buffer[0x413]);
			Put4bytes(0,&m_buffer[0x417]);
			Put4bytes(0,&m_buffer[0x41B]);
			for (j=0;j<8;j++) nAud[j]=0;
			for (j=0 ; j<ilastpack+1 && m_bInProcess; j++)
			{
				if (IsAudio(&m_buffer[2048*j])	&& bAudio)
				{
					i64auxp1++; 
					iAud=getAudId(&m_buffer[2048*j]) &0x7;
					if (nAud[iAud]==0) nAud[iAud]=j;
				}
				else if (IsSubs (&m_buffer[2048*j])) i64auxp1++;
			}
			Put4bytes(i64auxp1,&m_buffer[0x40f]);
			Put4bytes(0,&m_buffer[0x413]);
			Put4bytes(0,&m_buffer[0x417]);
			Put4bytes(0,&m_buffer[0x41B]);

		}
		if (bFirstVobu)
		{
			i64auxp1=i64auxp2=0;
			for (j=0;j<8;j++) nAud[j]=0;
			scr=readscr(m_buffer); // reads nav scr...
			nInserted=0;
			for (j=1, bInserting=true; j<ilastpack+1; j++)
			{
				if ((IsAudio(&m_buffer[2048*j])	&& bAudio) || 
				    (IsSubs (&m_buffer[2048*j])) )
				{
					i64auxp1++;
					if (bInserting)
					{
						scr_new=readscr(m_buffer+j*2048);
						if (scr_new > scr+146)
							nToBeInserted=(int)((scr_new-scr)/147 -1);
						else nToBeInserted=0;
	// First non-nav MUST be a video
						if (nToBeInserted==0 && nInserted==0) nToBeInserted=1;

						if (nInserted+nToBeInserted >= nPacksIFrame)
						{
							nToBeInserted=nPacksIFrame-nInserted;
							bInserting=false;
							i64auxp2+=nToBeInserted;
						}
						else
							i64auxp2+=(nToBeInserted+1);

						nInserted+=nToBeInserted;
						scr=scr_new;
					}
				}
				if (IsAudio(&m_buffer[2048*j])	&& bAudio)
				{
					iAud=getAudId(&m_buffer[2048*j]) &0x7;
					if (nAud[iAud]==0) nAud[iAud]=j;
				}
			}
			if (bInserting)
			{
				nToBeInserted=nPacksIFrame-nInserted;
				nInserted+=nToBeInserted;
				i64auxp2+=nToBeInserted;
				bInserting=false;
			}

			i64auxp1+=nPacksIFrame;
			Put4bytes(i64auxp1,&m_buffer[0x40f]);
// Modified 29-12-2005
			if (bAudio)
				Put4bytes(i64auxp2,&m_buffer[0x413]);
			else
				Put4bytes(i64auxp1,&m_buffer[0x413]);
			Put4bytes(0,&m_buffer[0x417]);
			Put4bytes(0,&m_buffer[0x41B]);
		}
// SRI pointers
		Put4bytes(0xBFFFFFFF,&m_buffer[0x4F1]);
		for (i=0;i<19;i++)
			Put4bytes(0x3FFFFFFF,&m_buffer[0x4F5+i*4]);
		Put4bytes(0x3FFFFFFF,&m_buffer[0x541]);
		Put4bytes(0x3FFFFFFF,&m_buffer[0x545]);
		for (i=0;i<19;i++)
			Put4bytes(0x3FFFFFFF,&m_buffer[0x549+i*4]);

		Put4bytes(0xBFFFFFFF,&m_buffer[0x595]);
// Adjust Previous VOBU pointers
		if (!bFirstVobu && bAudio)
		{
			Put4bytes((UINT)0x80000000+(UINT)(ilastpack_old+1),&m_buffer[0x545]);
			Put4bytes((UINT)0x80000000+(UINT)(ilastpack_old+1),&m_buffer[0x549]);
		}
// Adjust Last VOBU pointers
		if (!bLastVobu && bAudio)
		{
			Put4bytes(ilastpack+1,&m_buffer[0x53d]);
			Put4bytes(ilastpack+1,&m_buffer[0x541]);
		}

//  SYNCI audio pointers
		for (i=0;i<8;i++)
		{
			if (!bAudio) Put2bytes(0,&m_buffer[0x599+i*2]);
// Not true, but who needs delay adjustments audio/video in a still?
			if (bAudio)
				Put2bytes(nAud[i],&m_buffer[0x599+i*2]);
		}

//  SYNCI subs pointers
		for (i=0;i<32;i++)
		{
			i64SubP=GetNbytes(4,&m_buffer[0x5a9+4*i]);
			if (i64SubP!=0)
			{
				if (bFirstVobu)
					Put4bytes(0x7FFFFFFF,&m_buffer[0x5a9+4*i]);
				if (!bFirstVobu && bAudio)
					Put4bytes(nPacksWritten | 0x80000000 ,&m_buffer[0x5a9+4*i]);
			}
		}

//////////////////////////////////////////////////////////////////
// Patch SUBS
//////////////////////////////////////////////////////////////////
		if (bFirstVobu && !bAudio)
		{
			for (i=0;i<32;i++)
			{
// Demux the Sub into memory: mySubs
				nIndex=0;
				for (j=1,nIndex=0; j<ilastpack+1;j++)
				{
					nSubId=getSubId (&m_buffer[2048*j]);
				    if ( nSubId== (0x20+i))
					{
						iSubsStart=0x17+m_buffer[2048*j+0x16];
						nbytes=m_buffer[2048*j+0x12]*256+m_buffer[2048*j+0x13]+0x14;
						nbytes=nbytes-iSubsStart-1;
						for (k=0; k<nbytes;k++)
							mySubs[nIndex+k]=m_buffer[2048*j+iSubsStart+1+k];
						nIndex+=nbytes;
					}
				}
				if (nIndex > 0)
				{
// Now, we have the sub stream in mySubs...
// Going to patch it
					nSize=mySubs[0]*256+mySubs[1];
					nNewIndex=mySubs[2]*256+mySubs[3];
					if (nIndex !=nSize)
					{
						csAux.Format(_T("     WARNING: Something was wrong in subs size in Cell %d."),nCell+1);
						MyLog(csAux,ORANGE);
						m_nWarnings++;
						nNewIndex=-1;
					}
					nIndex=0;
					nBlocks=0;
					while (nNewIndex!=nIndex && nNewIndex >=0)
					{
						nIndex=nNewIndex;
						nNewIndex=mySubs[nIndex+2]*256+mySubs[nIndex+3];
						if (nNewIndex > nSize-4)
						{
							csAux.Format(_T("     WARNING: Something was wrong decoding subs in Cell %d."),nCell+1);
							MyLog(csAux,ORANGE);
							m_nWarnings++;
							nNewIndex=-1;
						}
						nBlocks++;
					}

					if (nNewIndex>0 && nBlocks>1)
					{
// Found more than one block of commands. checking if it is a stop and patching
						if (mySubs[nIndex+4] == 02)
						{
							csAux.Format(_T("     NOTE: Patching a timed stop in subs of Cell %d."),nCell+1);
							MyLog(csAux,CIAN15);
							m_nNotes++;
							mySubs[nIndex+4] = 0xFF;
							mySubs[nIndex+0] = 00;
							mySubs[nIndex+1] = 00;
						}
					}

// Muxing it again
					for (j=0,nIndex=0; j<ilastpack+1;j++)
					{
					    if (getSubId (&m_buffer[2048*j]) == (0x20+i))
						{
							iSubsStart=0x17+m_buffer[2048*j+0x16];
							nbytes=m_buffer[2048*j+0x12]*256+m_buffer[2048*j+0x13]+0x14;
							nbytes=nbytes-iSubsStart-1;
							for (k=0; k<nbytes;k++)
								m_buffer[2048*j+iSubsStart+1+k]=mySubs[nIndex+k];
							nIndex+=nbytes;
						}
					}
				} // if nIndex > 0
			} // for i=0..to ..32
		}

///////////////////////////////////////////////////////////////////
//Write VOBU
///////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//   Following VOBUs, different to the first one (only in audio mode)
//////////////////////////////////////////////////////////////////////
		if (!bFirstVobu && bAudio ) 
		{
			nPacksWritten+=(int)(i64auxp1+1);
			vobu_e_ptm=GetNbytes(4,&m_buffer[0x3d]);
			for (j=0 ; j<ilastpack+1 && m_bInProcess; j++)
			{
//				scr=readscr(m_buffer+j*2048);
//				scr_ext=readscr_ext(m_buffer+j*2048);
				if (IsNav(&m_buffer[2048*j]))
				{
					ModifyCID (&m_buffer[2048*j],NVID,NCID);
					WritePack(&m_buffer[2048*j],nVTS);
				}
				else if (IsAudio(&m_buffer[2048*j])	&& bAudio) 
					WritePack(&m_buffer[2048*j],nVTS);
				else if (IsSubs (&m_buffer[2048*j]))
				{
					// patch subs PTS (I'm blind here..)
//					if (m_buffer[2048*j+0x15] & 0x80) 
//						writepts(&m_buffer[2048*j+0x17],videopts);
					WritePack(&m_buffer[2048*j],nVTS);
				}
			}
		}
		if (!bFirstVobu && !bSecondVobu && !bAudio ) 
		{
			for (j=0 ; j<ilastpack+1 && m_bInProcess; j++)
			{
// Check Lost Subs if no audio! in third and following packs!!
				if (IsSubs (&m_buffer[2048*j]) && !bSubsWarned)
				{
					csAux.Format(_T("     WARNING: Find subs in a VOBU different from the first one, the before and after in cell %d. They will be lost!"),nCell+1);
					MyLog(csAux,ORANGE);
					m_nWarnings++;
					bSubsWarned=true;
				}
			}
		}
//////////////////////////////////////////////////////////////////////
//   First VOBU
//////////////////////////////////////////////////////////////////////
		if (bFirstVobu)
		{
/////////Presentation Times of VOBU////////////////
			nPacksWritten+=(int)(i64auxp1+1);
			vobu_s_ptm=GetNbytes(4,&m_buffer[0x39]);
			vobu_e_ptm=GetNbytes(4,&m_buffer[0x3d]);
//			vobu_se_e_ptm=GetNbytes(4,&m_buffer[0x41]);

			iVideoAttr=m_iMVideoAttr[nVTS];
			iFormat=(iVideoAttr & 0x1000) >> 12;
			if (iFormat==NTSC) 
			{
				vobu_se_e_ptm=vobu_s_ptm+3003;
				videopts=vobu_s_ptm;
				videodts=vobu_s_ptm-3003;
			}
			else
			{
				vobu_se_e_ptm=vobu_s_ptm+3600;
				videopts=vobu_s_ptm;
				videodts=vobu_s_ptm-3600;
			}
			Put4bytes(vobu_se_e_ptm,&m_buffer[0x41]);
			if (!bAudio) 
			{
				vobu_e_ptm=vobu_se_e_ptm;
				Put4bytes(vobu_e_ptm,&m_buffer[0x3d]);
			}

// Clear elapsed time
			if (!bAudio)
			{
				if (iFormat==NTSC) 
						Put4bytes(0xC0,&m_buffer[0x45]);
				else
						Put4bytes(0x40,&m_buffer[0x45]);
			}

// Modified 29-Dec-2005: Patch 0x433 and 0x437 (Video presentation times)
			Put4bytes(vobu_s_ptm,&m_buffer[0x433]);
			Put4bytes(vobu_se_e_ptm,&m_buffer[0x437]);

			if (nButtons)
			{
// Modify highligth times
				Put4bytes(vobu_s_ptm,&m_buffer[0x8f]);
				Put4bytes(0xFFFFFFFF,&m_buffer[0x93]);
				Put4bytes(0xFFFFFFFF,&m_buffer[0x97]);
// Modify highlight status
				Put2bytes(         1,&m_buffer[0x8d]);
			}
// Write Nav pack
			ModifyCID (&m_buffer[0],NVID,NCID);
			WritePack(&m_buffer[0],nVTS);
		}

/////////////////////////////////////////////////////////////
// First VOBU IN CASE OF AUDIO: 
///////////////////////////////////////////////////////////
		if (bFirstVobu && bAudio)
		{
			scr=readscr(m_buffer); // reads nav scr...
			scr_ext=readscr_ext(m_buffer); // reads nav scr_ext...

			nInserted=0;
			for (j=1, bInserting=true; j<ilastpack+1 ; j++)
			{
				if ((IsAudio(&m_buffer[2048*j]) && bAudio) || 
				    (IsSubs (&m_buffer[2048*j])) )
				{
					if (bInserting)
					{
						scr_new=readscr(m_buffer+j*2048);

						if (scr_new > scr+146)
							nToBeInserted=(int)((scr_new-scr)/147 -1);
						else nToBeInserted=0;

	// First non-nav MUST be a video
						if (nToBeInserted==0 && nInserted==0) nToBeInserted=1;

						if (nInserted+nToBeInserted >= nPacksIFrame)
						{
							nToBeInserted=nPacksIFrame-nInserted;
							bInserting=false;
						}
						for (i=0; i<nToBeInserted; i++)
						{
							scr+=146;
							scr_ext+=86;
							if (scr_ext > 299) {scr++; scr_ext-=300;}
							writescr(scr,scr_ext, &m_IFrame[2048*(nInserted+i)]);
							if ((nInserted+i)==0)
							// patch video pts/dts
							{
								if (m_IFrame[0x15] & 0x80) 
									writepts(&m_IFrame[0x17],videopts);
								if (m_IFrame[0x15] & 0x40) 
									writepts(&m_IFrame[0x17+5],videodts);
							}
							WritePack(&m_IFrame[2048*(nInserted+i)],nVTS);
						}
						nInserted+=nToBeInserted;
						scr=scr_new;
						scr_ext=readscr_ext(m_buffer+j*2048); // reads next scr_ext...
					}
// patch subs PTS  
				    if (IsSubs (&m_buffer[2048*j])) 
					{
						if (m_buffer[2048*j+0x15] & 0x80) 
							writepts(&m_buffer[2048*j+0x17],videopts);
					}
					WritePack(&m_buffer[2048*j],nVTS);
				}
			}
			if (bInserting)
			{
				nToBeInserted=nPacksIFrame-nInserted;
				bInserting=false;
				for (i=0; i<nToBeInserted; i++)
				{
					scr+=146;
					scr_ext+=86;
					if (scr_ext > 299) {scr++; scr_ext-=300;}
					writescr(scr,scr_ext, &m_IFrame[2048*(nInserted+i)]);
					WritePack(&m_IFrame[2048*(nInserted+i)],nVTS);
				}
			}
		}


/////////////////////////////////////////////////////////////
// First VOBU IN CASE OF NO AUDIO: 29-12-2005. Change the method 
///////////////////////////////////////////////////////////
// Now the scr is recalculated always, and the order of the packs is
// forced to:
//		Insert one video
//		All the subs
//		Rest of the video.

		if (bFirstVobu && !bAudio)
		{

			scr=readscr(m_buffer); // reads nav scr...
			scr_ext=readscr_ext(m_buffer); // reads nav scr_ext...

			scr+=146;
			scr_ext+=86;
			if (scr_ext > 299) {scr++; scr_ext-=300;}
//STEP 1: Write first Video Pack
			writescr(scr,scr_ext, &m_IFrame[0]);
		// patch video pts/dts
			if (m_IFrame[0x15] & 0x80) 
				writepts(&m_IFrame[0x17],videopts);
			if (m_IFrame[0x15] & 0x40) 
				writepts(&m_IFrame[0x17+5],videodts);
			WritePack(&m_IFrame[0],nVTS);
//STEP 2: Write All subs
			for (j=1; j<ilastpack+1 ; j++)
			{
				if (IsSubs (&m_buffer[2048*j]))
				{
					scr+=146;
					scr_ext+=86;
					if (scr_ext > 299) {scr++; scr_ext-=300;}
					writescr(scr,scr_ext, &m_buffer[2048*j]);
// patch subs PTS  
					if (m_buffer[2048*j+0x15] & 0x80) 
						writepts(&m_buffer[2048*j+0x17],videopts);
					WritePack(&m_buffer[2048*j],nVTS);
				}
			}
// STEP 3: Rest of the video 
			for (j=1; j<nPacksIFrame; j++)
			{
				scr+=146;
				scr_ext+=86;
				if (scr_ext > 299) {scr++; scr_ext-=300;}
				writescr(scr,scr_ext, &m_IFrame[2048*j]);
				WritePack(&m_IFrame[2048*j],nVTS);
			}
		}


		if (bSecondVobu) bSecondVobu=false;

		if (bFirstVobu)
		{
			bFirstVobu=false;
			bSecondVobu=true;
		}
		
	}

	delete [] m_IFrame;
	if (m_Fin !=NULL) fclose (m_Fin); 

}

